#ifndef COARRAY
#define COARRAY

#include "httpd.h"
#include "co_utils.h"

#define __ARRAY_MAGIC_NUMBER 654321

#define __ARRAY_BLOCK_SIZE 100

#define COARRAY_TYPE_STRING  1
#define COARRAY_TYPE_OBJECT  2

typedef struct co_array_of_pointers co_array_of_pointers;

// Constructor
co_array_of_pointers * coa_Create        (co_context * cnx);
co_array_of_pointers * coa_CreateTyped   (co_context * cnx, int type);

// Get Methods
int      coa_GetElementCount     (co_context * cnx, const co_array_of_pointers * coar);
void *   coa_GetElement          (co_context * cnx, const co_array_of_pointers * coar, int elem_num);
const char * coa_GetStringElement(co_context * cnx, const co_array_of_pointers * coar, int elem_num);
char *   coa_GetCopyOfElement    (co_context * cnx, const co_array_of_pointers * coar, int elem_num);

// Test Methods
int      coa_IsArray             (co_context * cnx, const co_array_of_pointers * coar);

// Manipulate Methods
int      coa_AppendElement       (co_context * cnx, co_array_of_pointers * coar, void * new_value);
int      coa_AppendCopyOfElement (co_context * cnx, co_array_of_pointers * coar, const char * new_value);
int      coa_AppendSplit         (co_context * cnx, co_array_of_pointers * coar, const char * str_to_split, const char * delim);
int      coa_SetElement          (co_context * cnx, co_array_of_pointers * coar, int elem_num, void * new_value);

// Copy Methods
co_array_of_pointers *  coa_Copy                (co_context * cnx, const co_array_of_pointers * coar);


#endif

