#include <ctype.h> /* toupper() */

/* borrowed from wget 1.5.3 url.c */
/* macros found in wget.h */
/* ASCII char -> HEX digit */
#define ASC2HEXD(x) \
        (((x) >= '0' && (x) <= '9') ? \
	((x) - '0') : (toupper(x) - 'A' + 10))

/* HEX digit -> ASCII char */
#define HEXD2ASC(x) (((x) < 10) ? ((x) + '0') : ((x) - 10 + 'A'))

/* ??? could not find it, so I wrote it. R.G. ;) */
#define ISXDIGIT(x) \
    (((x) >= '0' && (x) <= '9') || \
     ((x) >= 'A' && (x) <= 'F') || \
     ((x) >= 'a' && (x) <= 'f') \
 )

void
cou_decode_string (char *s)
{
  char *p = s;

  for (; *s; s++, p++)
  {
	if (*s != '%') 
		*p = *s;
	else
	{
	  /* Do nothing if at the end of the string, or if the chars
	     are not hex-digits.  */
	  if (!*(s + 1) || !*(s + 2) || 
	   !( ISXDIGIT ( *(s + 1) ) && ISXDIGIT ( *(s + 2) ) )
	   )
	  {
	      *p = *s;
	      continue;
	  }
	  *p = (ASC2HEXD (*(s + 1)) << 4) + ASC2HEXD (*(s + 2));
	  s += 2;
	}
    }
  *p = '\0';
}

void
cou_decode_string_post (char *s)
{
  char *p = s;

  for (; *s; s++, p++)
  {
	if (*s == '+')
		*p = ' ';
	else if (*s != '%') 
		*p = *s;
	else
	{
	  /* Do nothing if at the end of the string, or if the chars
	     are not hex-digits.  */
	  if (!*(s + 1) || !*(s + 2) || 
	   !( ISXDIGIT ( *(s + 1) ) && ISXDIGIT ( *(s + 2) ) )
	   )
	  {
	      *p = *s;
	      continue;
	  }
	  *p = (ASC2HEXD (*(s + 1)) << 4) + ASC2HEXD (*(s + 2));
	  s += 2;
	}
    }
  *p = '\0';
}
