/* only for use while defining JavaScript environment */
#ifdef INSIDE_CO_JS

typedef struct {
    co_context* cocnx;
	struct co_string* errmsg;
    /* for event/method implementation */
    void *in_params;
    const char *method_name;
    const char *target_name;
    /* -- */
    int (*ln_trans)(const char *, int);
    /* writes_buffer keeps inflated (UC) characters */
    void *writes_buffer; /* initially NULL == means writes are made direct to client */
    size_t buffer_length;

	/* js creation state: mark + saved context */
	int withinJSCreation;
	co_client_mode saved_client_mode;
	int saved_send_data;

} co_js_context;

#endif

#ifdef JSVAL_OBJECT
/* retrieves co_context* from JavaScript context */
extern
co_context*
cjs_getCOContext(JSContext *cx);

void
cjs_dumpErrorMessages(JSContext *cx);

void
cjs_setCOInParams(JSContext *cx, void *in_params);

void*
cjs_getCOInParams(JSContext *cx);

void
cjs_setCOMethodName(JSContext *cx, const char *method_name);

const char *
cjs_getCOMethodName(JSContext *cx);

void
cjs_setCOTargetName(JSContext *cx, const char *target_class_name);

const char *
cjs_getCOTargetName(JSContext *cx);

/*
set line translation used in error messages; i.e. function int -> int
  <script line number> -> <source line number> 
co_translate_line from ap_pareser.h is used for asp pages
*/
extern
void
cjs_setCOLineTranslation(JSContext *cx, int (*ln_trans)(const char *, int) );

/* set identity as line translation */
extern
void
cjs_setDefaultCOLineTranslation(JSContext *cx);

#endif

/* precompile all scripts needed to establish execution context */
extern
void
cox_compileJSScript(server_rec *s, pool *p, coffice_server_conf *coffice_sconf);

/* init new execution context in previously created runtime */
/* specify if line transaction for asp should be used */
extern
void
cox_initJSContext( co_context *cnx, bool for_asp);

/* destroy all contexts except compilation context for 
runtime used in this request */
extern
void
cox_finishJSContext(co_context *cnx);

/* create new runtime; set it in module config struct for later use */
extern
void
cox_initJSRuntime(coffice_server_conf *coffice_sconf);

/* destroy runtime */
extern
void
cox_finishJSRuntime(coffice_server_conf *coffice_sconf);

/*
extern
void
cjs_setCOInParams(JSContext *cx, void *in_params);

extern
void*
cjs_getCOInParams(JSContext *cx);
*/

