#include "libpq-fe.h"

#include "co_lib.h"

#include "co_session.h"

#define SQLBUFSIZE 10000

static char SQLString[SQLBUFSIZE];

/* creates new session for given user id, sets session_id in co_context */
int cou_assignNewSession( co_context *cnx )
{
    PGresult *res;
    int id_session;

    sprintf(SQLString,
"
SELECT co_%s_session_createNew (%d);
",
    cnx->par_area, cnx->id_user );
    res = PQexec(cnx->dbconn, SQLString);
    if (PQresultStatus(res) != PGRES_TUPLES_OK)
         cou_error( cnx, "Error while assigning new session" );

    id_session = atoi(PQgetvalue(res, 0, 0));
    PQclear(res);

    cnx->id_session = id_session;
    return id_session;
}