#ifndef COSTRINGH
#define COSTRINGH

#define COSTR_MAGIC_NUMBER 7654321
#define COSTRELM_MAGIC_NUMBER 7654312

typedef struct co_string co_string;

co_string *
cos_CreateEmpty(co_context * cnx);

int
cos_AppendString(co_context * cnx, co_string * costr, const char * str);

#define cos_AppendFormatted(cnx, costr, format, args... ) \
    cos_AppendString(cnx, costr, ap_psprintf(cnx->request->pool, format, ## args ) )

#define cos_AppendCopyOfString(cnx, costr, str ) \
    cos_AppendString(cnx, costr, ap_pstrdup(cnx->request->pool, str) )

char *
cos_GetSimplifiedString(co_context * cnx, const co_string * costr);

int
cos_SendString(co_context * cnx, const co_string * costr);

#endif