#include "../../include/types.t"

class acl_class
{
   
   doc "This class is used to keep acls on the class basis";

   area sec;

#include "../../include/check_acl.t"
   
   inherits generic;
   
   container_class '';
   container_column_name '';

#include "../../include/generic_props.t"

  index in1 
  { 
    unique 0; 
    column id_permission; 
    column id_role; 
    column class_name; 
    column area; 
  }; 

  index in2 
  { 
    unique 0; 
    column id_role; 
    column class_name; 
    column area; 
  }; 

  index in2 
  { 
    unique 0; 
    column class_name; 
    column area; 
  }; 



   prop id_permission
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'permission';
     foreign_prop 'id';
     position 200;
   };
   
   prop id_role
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 1;
     foreign 'role';
     foreign_prop 'id';
     position 200;

   };

   prop area
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'id';
     position 200;
   };
 
	function_sql check
	{
		doc "check acl for given area, class_name, id_permission and id_role";
		params '(text, text, int, int)';
		returns int;
		language sql;

		S
		%%
		SELECT 1 FROM co_sec_acl_class
			WHERE area = $1 AND class_name = $2 AND id_permission = $3 AND id_role = $4 ;   
		%%
		;
	};  

  
};  
