#include "httpd.h"
#include "co_lib.h"
#include "libpq-fe.h"

#include "co_example.h"

/* This simple module demonstrates use of putJS and logError */
/* should be called with 
 *  .../html/example?showExample or .../javascript/example?showExample
 */
int co_showExample(co_context *ctx, void* in_params)
{
    cou_logError( ctx, CO_LOG_DEBUG, "co_showExample called");
    /* or e.g. :
     *  cou_logError( ctx, CO_LOG_ERR, "co_showExample: wrong params");
     */

    if (ctx->putJS) cou_putJS( ctx, "alert('Message from Example (JavaScript)');");
    else ap_rputs( "<BODY><H2>Message from Example (HTML)</H2></BODY>", ctx->request );
    return 0;
}

int co_showError(co_context *ctx)
{
    char *callback;
    int err;
    cou_logError( ctx, CO_LOG_DEBUG, "co_showError called");

  callback = (char*)cou_getParam(ctx,"callback",CO_STRING_SQL_VALUE, &err);

//    cou_error( ctx, "Did a boo-boo" );
    return 0;
}

int co_returnSeven(co_context *ctx)
{
    cou_logError( ctx, CO_LOG_DEBUG, "co_returnSeven called");
    {
	int val = 7;
	cou_setReturnValue( ctx, (void*)&val, CO_INTEGER );
    }
    return 0;
}


int co_returnRecordset(co_context *ctx)
{
    PGresult *res;
    res = PQexec(ctx->dbconn, "select * from db_testowa");
    if (PQresultStatus(res) != PGRES_TUPLES_OK)
    {
            PQclear(res);
    }
    else {
	cou_setReturnValue( ctx, (void*)res, CO_RECORDSET );
    }
    return 0;
}

#define TMP_BUF_LEN 255
int co_addToRecordset(co_context *ctx, void *in_params )
{
    char buf[TMP_BUF_LEN+1];
    PGresult *res;
    co_typein_example_addToRecordset *p;
    p = (co_typein_example_addToRecordset *)in_params;
    snprintf( buf, TMP_BUF_LEN, "insert into %s values(%d,%d);", p->dbname, p->value1, p->value2 );
    buf[TMP_BUF_LEN] = '\0';
    res = PQexec(ctx->dbconn, buf );
    if (PQresultStatus(res) != PGRES_COMMAND_OK)
    {
            PQclear(res);
	    cou_error( ctx, "SQL command failed" );
    }
    PQclear(res);
    return 0;
}
