#include "../../include/init_file_names.t"  
#include "defines.t"

file __INIT_LIB_EXPRESSION()
{

class js_lib
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='expression_parser'";
  p id_js_code {val '-1';};
  p name {val 'expression_parser';};
};

class js_code
{
  area sys;
  full_control root;
  full_control user;
  p code {val
   %%

function getAllColumnIds()
{
  var method = new COMethod( 'sys', 'spreadsheet', 'getAllColumnIds' );
  method.setParam( 'par_id', sp_id);
  method.setParam( 'par_area', 'sys');
  method.setParam( 'par_class', 'spreadsheet');
  method.call();
  var ids = new Array();
  var names = new Array();
  var ntuples = co_getretRSntuples();
  var i;
  for (i = 0; i<ntuples; i++) {
    ids[i] = new Number(co_getretRSvalue(i,0));
    names[co_getretRSvalue(i,1)] = ids[i];
  }
  return new Array( ids, names );
}


function getAllRowIds()
{
  var method = new COMethod( 'sys', 'spreadsheet', 'getAllRowIds' );
  method.setParam( 'par_id', sp_id);
  method.setParam( 'par_area', 'sys');
  method.setParam( 'par_class', 'spreadsheet');
  method.call();
  var res = new Array();
  var ntuples = co_getretRSntuples();
  var li;
  for (li = 0; li<ntuples; li++) {
    res[li] = Number(co_getretRSvalue(li,0));
  }
  return res;
}

   %%
   ;
   };
};

class js_lib
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='expression_helpers'";
  p name {val 'expression_helpers';};
  p id_js_code {recent js_code;};
  p id_parent  {getByName       js_lib {f 'expression_parser';};};
};

class js_code
{
  area sys;
  full_control root;
  full_control user;
  p code {val
   %%
var expression = new Object();

expression.setExpression = function expression_setExpression(strExpression) {

  var method = new COMethod( 'sys', 'expression', 'setParsed' );
  method.setParam( 'par_id', context.spreadsheet_id);
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'expression_parsed',String(strExpression));

  method.call();
}

expression.setReferencedCell = function expression_setReferencedCell(numIndex /* as Integer */,
                     numCellColId, numCellRowId, 
	    numHardCol /* as Byte, use 0-1 */, numHardRow /* as Byte, use 0-1 */,
	    numNamedCol /* as Byte, use 0-1 */, numNamedRow /* as Byte, use 0-1 */) 
{

  var method = new COMethod( 'sys', 'expression_cell', 'setReferencedCell' );

  method.setParam( 'par_id', context.spreadsheet_id );
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index', numIndex );
  method.setParam( 'id_ref_spreadsheet', context.spreadsheet_id);
  method.setParam( 'id_ref_column', numCellColId);
  method.setParam( 'id_ref_row', numCellRowId);
  method.setParam( 'ref_column_hard',numHardCol);
  method.setParam( 'ref_row_hard',numHardRow);
  method.setParam( 'ref_column_named',numNamedCol);
  method.setParam( 'ref_row_named',numNamedRow);
  
  method.call();
}

expression.setReferencedRange = function expression_setReferencedRange(numIndex /* as Integer */,
		     numFunctionId,
                     numRangeColId, numRangeRowId, numHardCol /* as Byte, use 0-1 */, numHardRow /* as Byte, use 0-1 */,
		     numNamedCol, numNamedRow,
                     numRangeColId2, numRangeRowId2, numHardCol2 /* as Byte, use 0-1 */, numHardRow2 /* as Byte, use 0-1 */
,
		     numNamedCol2, numNamedRow2
                 ) {

  var method = new COMethod( 'sys', 'expression_range', 'setReferencedRange' );

  method.setParam( 'par_id', context.spreadsheet_id);
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index', numIndex );
  method.setParam( 'function', numFunctionId );
  method.setParam( 'id_ref_spreadsheet', context.spreadsheet_id);
  method.setParam( 'id_ref_column', Number(numRangeColId));
  method.setParam( 'id_ref_row', Number(numRangeRowId));
  method.setParam( 'ref_column_hard',Number(numHardCol));
  method.setParam( 'ref_row_hard',Number(numHardRow));
  method.setParam( 'ref_column_named',Number(numNamedCol));
  method.setParam( 'ref_row_named',Number(numNamedRow));
  method.setParam( 'id_ref_column2', Number(numRangeColId2));
  method.setParam( 'id_ref_row2', Number(numRangeRowId2));
  method.setParam( 'ref_column2_hard',Number(numHardCol2));
  method.setParam( 'ref_row2_hard',Number(numHardRow2));
  method.setParam( 'ref_column2_named',Number(numNamedCol2));
  method.setParam( 'ref_row2_named',Number(numNamedRow2));
  
  method.call();
}

expression.purgeCellRefs = function expression_purgeCellRefs(numFrom) {

  var method = new COMethod( 'sys', 'expression_cell', 'purgeExtraReferences' );
  method.setParam( 'par_id', context.spreadsheet_id);
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index_from', Number(numFrom));

  method.call();
}

expression.purgeRangeRefs = function expression_purgeRangeRefs(numFrom) {

  var method = new COMethod( 'sys', 'expression_range', 'purgeExtraReferences' );
  method.setParam( 'par_id', context.spreadsheet_id);
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index_from', Number(numFrom));

  method.call();
}

   %%
   ;
   };
};

class js_lib
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='expression_object'";
  p name {val 'expression_object';};
  p id_js_code {recent js_code;};
  p id_parent  {getByName       js_lib {f 'expression_parser';};};
};

class js_code
{
  area sys;
  full_control root;
  full_control user;
  p code {val
   %%
var sp_id = context.spreadsheet_id;

function show_message( strMessage )
{
  ap_write( "alert('" + (new String(strMessage)).replace(new RegExp("'", "g"),"\\'") + "');");
}

////////////// EXPRESSION PARSER /////////////////
// converts column letters (like A, B, ... AA,...) to column numbers
function convLetters2Number(strL)
{
  var uniA = "A".charCodeAt(0);
  var uniZ = "Z".charCodeAt(0);
  var mult = uniZ-uniA+1;
  var ch, col=0, row=0;
  // first sign is always '_', so skip it
  for (i=0; i<strL.length; i++) {
    ch = strL.charCodeAt(i);
    if (i>0) col *= mult;
    col += ch - uniA + 1;
  }
  return col;
}


var arrFunctionIds = new Array();
arrFunctionIds['sum']=0;
//arrFunctionIds['min']=1;
//arrFunctionIds['max']=2;

function parseExpression( strExpression )
{
 var strExpressionBak=strExpression;
// try {  
   var reQuot = /"([^\\"]|\\"|\\\\|\\t)+"/g;
//   var reCell = /\b([A-Z][0-9A-Z_]+!)?([A-Z]+)(\$?[1-9][0-9]*)\b/gi;
   var reCell = /([A-Z][0-9A-Z_]+!)?([A-Z]+|\[[^\]]+\])(\$?[1-9][0-9]*)\b/gi;
   var reCell1 = /([A-Z][0-9A-Z_]+!)?\$([A-Z]+|\[[^\]]+\])(\$?[1-9][0-9]*)/gi;
   var reCell2 = /\b__([A-Z][0-9A-Z_]+!)?(\$?[A-Z]+|\$?\[[^\]]+\])(\$?[1-9][0-9]*)__\b/gi;
   var reRange = /\b([A-Z][0-9A-Z_]+)\(__([A-Z][0-9A-Z_]+!)?(\$?[A-Z]+|\$?\[[^\]]+\])(\$?[1-9][0-9]*)__:__(\$?[A-Z]+|\$?\[[^\]]+\])(\$?[1-9][0-9]*)__\)/gi;
   // get num->id for cols & rows
   var col_id_LU;
   var row_id_LU;
   var col_id_RD;
   var row_id_RD;
   var arrStrings = strExpression.match(reQuot); // remember
   strExpression = strExpression.replace(reQuot, "__STR__");
   //client.addMessage(strExpression);
   var arrCols = getAllColumnIds()[0];
   var arrColNames = getAllColumnIds()[1];
//show_message(arrCols);

   var arrRows = getAllRowIds();
   strExpression = strExpression.replace(reCell1, "__$1$$$2$3__");
//show_message(strExpression);
   strExpression = strExpression.replace(reCell, "__$1$2$3__");
//show_message(strExpression);
   var bHardColLU, bHardRowLU, bHardColRD, bHardRowRD;
   var bNamedColLU, bNamedRowLU, bNamedColRD, bNamedRowRD;
   var strColLU, strRowLU, strColRD, strRowRD;
   var n=0;
   var arrMatches = reRange.exec(strExpression);
   while ((arrMatches != null) && (arrMatches.length>4)) {
       for (var i=1; i<arrMatches.length; i +=5) {
	   idFun = Number(arrFunctionIds[arrMatches[i].toLowerCase()]);
	   if (!idFun<arrFunctionIds.length) throw "Function "+arrMatches[i]+" is not suppoerted";
	    i++;
           // match pairs: col, row
           objSp = null;
	   /* external references not supported yet
           if (arrMatches[i]!='') {
              objSp = sp(arrMatches[i].substr(0, arrMatches[i].length-1));
              //.getColumn(1).getId());
           }
	   */
	   bNamedColLU = false;
	   bNamedRowLU = false;
	   bNamedColRD = false;
	   bNamedRowRD = false;
           strColLU = arrMatches[i+1];
           if (strColLU.charAt(0)=="$") { strColLU=strColLU.substr(1); bHardColLU=true; }
           else bHardColLU = false; 
           if ( objSp == null)
	      if (
strColLU.charAt(0)=="[") { 
		    col_id_LU = Number(arrColNames[strColLU.substr(1,strColLU.length-2)]);
		    bNamedColLU = true;
	      }
	      else
                col_id_LU = Number(arrCols[convLetters2Number(strColLU.toUpperCase())-1]);
           else
              col_id_LU = objSp.getColumn(convLetters2Number(strColLU.toUpperCase())).getId();
           strRowLU = arrMatches[i+2];
           if (strRowLU.charAt(0)=="$") { strRowLU=strRowLU.substr(1); bHardRowLU=true; }
           else bHardRowLU = false; 
           if ( objSp == null)
              row_id_LU = arrRows[Number(strRowLU)-1];
           else
              row_id_LU = objSp.getRow(Number(strRowLU)).getId();
           strColRD = arrMatches[i+3];
           if (strColRD.charAt(0)=="$") { strColRD=strColRD.substr(1); bHardColRD=true; }
           else bHardColRD = false; 
           if ( objSp == null)
	      if (
strColRD.charAt(0)=="[") { 
		    col_id_RD = Number(arrColNames[strColRD.substr(1,strColRD.length-2)]);
		    bNamedColRD = true;
	      }
	      else
        	col_id_RD = arrCols[convLetters2Number(strColRD.toUpperCase())-1];
           else
              col_id_RD = objSp.getColumn(convLetters2Number(strColRD.toUpperCase())).getId();
           strRowRD = arrMatches[i+4];
           if (strRowRD.charAt(0)=="$") { strRowRD=strRowRD.substr(1); bHardRowRD=true; }
           else bHardRowRD = false; 
           if ( objSp == null)
              row_id_RD = arrRows[Number(strRowRD)-1];
           else
              row_id_RD = objSp.getRow(Number(strRowRD)).getId();
           expression.setReferencedRange(n, idFun, 
		col_id_LU, row_id_LU, (bHardColLU?1:0), (bHardRowLU?1:0), (bNamedColLU?1:0), (bNamedRowLU?1:0), 
		col_id_RD, row_id_RD, (bHardColRD?1:0), (bHardRowRD?1:0), (bNamedColRD?1:0), (bNamedRowRD?1:0));
           strExpression = strExpression.replace( arrMatches[0], "__r("+n+")");
           n++;
       }
       arrMatches = reRange.exec(strExpression);
   }

   expression.purgeRangeRefs(n);

   arrMatches = reCell2.exec(strExpression);
   n=0;
   while (arrMatches != null) {
           // match pairs: col, row
//show_message(arrMatches.length);
           objSp = null;
	   /* external references not supported yet
           if (arrMatches[1]!='') {
              objSp = sp(arrMatches[1].substr(0, arrMatches[i].length-1));
              //.getColumn(1).getId());
           }
	   */
           strCol = arrMatches[2];
           if (strCol.charAt(0)=="$") { strCol=strCol.substr(1); bHardCol=true; }
           else bHardCol = false;
	   bNamedCol = false; bNamedRow = false;
           if ( objSp == null)
 {
//show_message(strCol);
	       if (
strCol.charAt(0)=="[") { 
		    col_id = Number(arrColNames[strCol.substr(1,strCol.length-2)]);
		    bNamedCol = true;
	       }
               else col_id = Number(arrCols[convLetters2Number(strCol.toUpperCase())-1]);
           } else
               col_id = objSp.getColumn(convLetters2Number(strCol.toUpperCase())).getId();
           strRow = arrMatches[3];
           if (strRow.charAt(0)=="$") { strRow=strRow.substr(1); bHardRow=true; }
           else bHardRow = false; 
           if ( objSp == null)
               row_id = arrRows[Number(strRow)-1];
           else
               row_id = objSp.getRow(Number(strRow)).getId();
           expression.setReferencedCell(n, col_id, row_id, (bHardCol?1:0), (bHardRow?1:0), (bNamedCol?1:0), (bNamedRow?1:0));
           strExpression = new String(strExpression.replace( arrMatches[0], "__c("+n+")"));
           n++;
 reCell2.exec("");
           arrMatches = reCell2.exec(strExpression);
   }

   expression.purgeCellRefs(n);

   if (arrStrings != null)
 {
      for (i=0; i<arrStrings.length; i++) {
          strExpression = strExpression.replace("__STR__", arrStrings[i]);
      }
;
   };

   // first try to execute, then save parsed expression
   var result = eval(strExpression.substr(1));
   expression.setExpression(String(strExpression));
//} catch (e) { result=strExpressionBak; }
   return result;
}

   %%
   ;
   };
};

class js_lib
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='expression_parser_implementation'";
  p name {val 'expression_parser_implementation';};
  p id_js_code {recent js_code;};
  p id_parent  {getByName       js_lib {f 'expression_parser';};};
};

class js_code
{
  area sys;
  full_control root;
  full_control user;
  p code {val
   %%
//////////// EXPRESSION EXECUTION ENVIRONMENT /////////////
function __c(n)
{
  var method = new COMethod( 'sys', 'expression_cell', 'getReferencedValue' );
  var retval;
  var retval2;
  method.setParam( 'par_id', context.spreadsheet_id );
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index', n );
  method.call();

  retval = co_getretString();
  retval2 = Number(retval);
  if (String(retval2) == 'NaN') retval2=retval;
  return retval2;

//  return "<__c("+n+")>";
}

function __r(n)
{
  var method = new COMethod( 'sys', 'expression_range', 'getReferencedValue' );
  var retval;
  var retval2;
  method.setParam( 'par_id', context.spreadsheet_id );
  method.setParam( 'id_column', context.column_id );
  method.setParam( 'id_row', context.row_id );
  method.setParam( 'index', n );
  method.call();

  retval = co_getretString();
  retval2 = Number(retval);
  if (String(retval2) == 'NaN') retval2=retval;
  return retval2;

//  return "<__r("+n+")>";
}

   %%
   ;
   };
};

class js_lib
{
  area sys;
  full_control root;
  full_control user;
  remove_old "name='expression_runtime'";
  p name {val 'expression_runtime';};
  p id_js_code {recent js_code;};
};

}; //file