#include "../../include/types.t"      
#include "../../include/defines.t"      

// CLASS MENU_ACTIONOR

class menu_action

{ 
  area "sec";
  area "sys";
  area "usr";

#include "../../include/check_acl.t"
  
  inherits generic_acl;
  
  container_class 'catalog';
  container_column_name 'id';
      
 // PROPERTIES
      
#include "../../include/generic_acl_props.t"      

  prop name    
  {      
    type CO_STRING;      
    default "''";      
    params '';      
    representant 1;      
    foreign '';      
    foreign_prop '';      
    position 200;    
  };    
  
  prop id_js_code
  {
    type CO_INTEGER;
    default 0;
    params '';
    representant 1;
    foreign 'js_code';
    foreign_prop 'id';
    position 300;
  };

// METHODS

//  include_c "co_jscript.h";
  include_c "../generic/co_generic.h";
  include_c "../js_code/co_js_code.h";
  
	method run
	{
		id_permission __PERMISSION_EVALUATE;
 
		__PARAMS_HEADER_WITH_CALLBACK
 
		declare language_c
		{
			C "int nTuples;";
			C "int id_js_code;";
			C "int i;";
			C 'const char *param_name;';
			C 'const char *param_type;';
			C 'const char *param_default;';
			C 'int param_optional;';
			C 'const char *param_value;';
		};
 
		body language_c
		{
			C 
			%%

			__SEND_MESG_DEBUG("entering run")
			/* getting id_js_code */
			@co_getProp(par_area, par_class ,par_id,'"id_js_code"');
			__ASSERT(err==0, "could not find menu_action id: %d", par_id)
			id_js_code = atoi(get_str);
		
			__SEND_MESG_DEBUG("id_js_code: %d", id_js_code)

			/* getting params */
			@co_getRelated(par_area, par_class,par_id, '"menu_action_param"');

			snprintf(JSOutBuf+strlen(JSOutBuf),JSBUFSIZE-strlen(JSOutBuf), "var context = new Object();\n");
 
			nTuples = cor_GetTupleCount(cnx, corec);
			for (i = 0; i < nTuples; i++)
			{
				param_name    = cor_GetCopyOfValueByName(cnx, corec, i, "param_name");
				param_type    = cor_GetCopyOfValueByName(cnx, corec, i, "param_type");
				param_default = cor_GetCopyOfValueByName(cnx, corec, i, "param_default");
				param_optional = atoi(cor_GetValueByName(cnx, corec, i, "param_optional"));

				param_value = (char *) cou_getParam(cnx,param_name,CO_STRING, &err);
				if(param_optional)
				{
					if(err==CO_PARAMETER_NOT_FOUND)
					{ 
						param_value = param_default;
						err=0;
					}
				}
				__ASSERT(err==0, "in menu_action::evaluate id_menu_action:%d parameter not optionall: %s",par_id,param_name) 
				snprintf(JSOutBuf+strlen(JSOutBuf),JSBUFSIZE-strlen(JSOutBuf), "context.%s ='%s'\n",param_name,param_value);
			}
    
			@co_call(par_area, '"js_code"', "evaluate", par_area=>par_area, par_class=>'"js_code"',par_id=>id_js_code, prolog=>JSOutBuf);
			__CREATE_JS_FROM_STRING("")
			%%
			;
		}; // body
	}; // method run
    
};

//END OF CLASS CATALOG
