#include "../../include/types.t"
#include "../../include/defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER

class meta_vtable
{
   area usr
   {
       force_sec_type 1;
   };
   area sys
   {
       force_sec_type 1;
   };
   area sec
   {
       force_sec_type 1;
   };

#include "../../include/check_acl.t"

   container_class 'meta_class';
   container_column_name 'class_name';

#include "../../include/generic_acl_props.t"

  index in1 
  { 
    unique 0; 
    column class_name; 
    column method_name; 
  }; 

   prop class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 200;
   };

   prop method_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 100;
     foreign '';
     foreign_prop '';
     position 200;

   };
   
   prop target_class_name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 0;
     foreign 'meta_class';
     foreign_prop 'class_name';
     position 200;
   };

   prop id_permission
   {
     type CO_INTEGER;
     default "''";
     params '';
     representant 0;
     foreign 'permission';
     foreign_prop 'id';
     position 200;
   };

   prop id_onbefore_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 200;
   };

   prop id_onbefore_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 200;
   };

   prop id_onafter_script
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'js_code';
     foreign_prop 'id';
     position 200;
   };

   prop id_onafter_method
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign 'meta_method';
     foreign_prop 'id';
     position 200;
   };

   prop profiled
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 210;
   };

   prop sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(1,2);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };

   prop force_sec_type
   {
     type CO_INTEGER;
     default 0;
     params 'VALUES=new Array(0, 1);';
     representant 0;
     foreign '';
     foreign_prop '';
     position 220;
   };


 
   
   inherits generic_acl;
   
   function_sql generate
   {
     doc "generates vtable entries for given class";
     params '(text)';
     returns int;

// we put this as perl code!     
   S
   %%
   @"
     DECLARE
       _class_name ALIAS FOR \$1;
       _current_class text;
       _force_sec_type int;
     BEGIN
      
        SELECT force_sec_type INTO _force_sec_type FROM co_${name_area}_meta_class WHERE class_name = _class_name;
        delete from co_${name_area}_meta_vtable where class_name = _class_name;
	  
        _current_class := _class_name;
       WHILE NOT(_current_class ISNULL) AND char_length(_current_class::text) > 0 LOOP
	        
         INSERT INTO co_${name_area}_meta_vtable(class_name, method_name, target_class_name, id_permission, 
                                                 id_onbefore_script, id_onbefore_method, id_onafter_script, id_onafter_method, profiled, sec_type, force_sec_type)
         SELECT _class_name, method_name, _current_class, id_permission, 
                id_onbefore_script, id_onbefore_method, id_onafter_script, id_onafter_method, profiled, sec_type, _force_sec_type
            FROM co_${name_area}_meta_method  
            WHERE _current_class = class_name AND NOT 
               method_name IN
               (
                SELECT method_name FROM co_${name_area}_meta_vtable  
                WHERE _class_name = class_name
               );
            
         select inherits_from into  _current_class from co_${name_area}_meta_class where class_name = _current_class;
					   
       END LOOP;
					    
       RETURN 1;
    END;  
    "
   %%
   ;
   };


   function_sql test_acl
   {
     doc "generates vtable entries for given class";
     params '@ "(co_${name_area}_meta_vtable, int, int)"';
     returns int;
	language 'sql';

// we put this as perl code!     
   S
   %%
   @"
  SELECT
    CASE WHEN \$1.sec_type=1 OR \$1.force_sec_type=1
      THEN
        co_sec_acl_class_check(\\'$name_area\\', \$1.class_name, \$1.id_permission, \$3)
      ELSE
        co_sec_acl_check(\\'$name_area\\', \$1.class_name, \$2, \$1.id_permission, \$3)
      END; 
     "
   %%
   ;
   };


};
