#include "../../include/defines.t"
#include "../../include/types.t"
   
class shell_command
{
   
	area usr;
	area sys;
	area sec;

#include "../../include/check_acl.t"
   
	inherits generic_acl;
   
	container_class '';
	container_column_name '';

#include "../../include/generic_acl_props.t"

	prop name
	{
		type CO_STRING;
		default "''";
		params '';
		representant 100;
		foreign '';
		foreign_prop '';
		position 200;
	};
    prop description
	{
		type CO_STRING;
		default "''";
		params 'SIZE=150';
		representant 0;
		foreign '';
		foreign_prop '';
		position 300;
	};
                  
	prop command
	{
		type CO_STRING;
		default "''";
		params 'SIZE=150';
		representant 0;
		foreign '';
		foreign_prop '';
		position 400;
	};

	include_c "stdlib.h";

	method exec_command
	{
		doc "This method executes current command";
		id_permission __PERMISSION_EVALUATE;

		__PARAMS_HEADER_WITH_CALLBACK

		declare language_c
		{
			C ' const char * command = ""; ';
			C ' int ret_val; ';
		};

		body language_c
		{
			C
			%%
				__SQL_GET_STRING(command, "SELECT command FROM cov_%s_shell_command WHERE id=%d", par_area, par_id)
				ret_val = system(command);
				__RETURN_INTEGER(ret_val)
				__CREATE_JS_FROM_INTEGER(ret_val)
			%%
			;
		};
	};
};