// TYPES FOR CO

#include "../../include/types.t"
#include "../../include/defines.t"
#define __ACL_HEADER __PARAMS_HEADER
// CLASS spreadsheet

class spreadsheet
{
  area sys;

#include "../../include/check_acl.t"

 // PROPERTIES

#include "../../include/generic_props.t"

  default_form "edit";

  prop name
  {
    type CO_STRING;
    default "''";
    params '';
    representant 1;
    foreign '';
    foreign_prop '';
    position 44;
  };

  prop cols
  {
    f_body
    %%
    select max(column_number) from co_sys_spreadsheet_column where spreadsheet_id=($1.id);
    %%
    ;
    type CO_INTEGER;
    default 0;
    params '';
    representant 1;
    foreign '';
    foreign_prop '';
    position 44;
  };

  prop rows
  {
    f_body
    %%
    select max(row_number) from co_sys_spreadsheet_row where spreadsheet_id=($1.id);
    %%
    ;
    type CO_INTEGER;
    default 0;
    params '';
    representant 1;
    foreign '';
    foreign_prop '';
    position 44;
  };


  inherits generic_acl;

  include_c "http_protocol.h";
  include_c "co_context.h";
  include_c "../coffice/co_output.h";
  include_c "co_session.h";

  uses "expression";
  uses "js_code";
  uses "profiler";
  uses "generic";

  container_class '';
  container_column_name '';

 // METHODS

  method etest1
  {
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    body language_c
    {
     C
     %%
     ap_rputs("alert(777);",r);
     %%
     ;
    };
  };

  method etest2
  {
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    body language_c
    {
     C
     %%
     ap_rputs("alert(707);",r);
     %%
     ;
    };
  };

  method refresh
  {
    doc "does nothing, so just gets actions for user session";
    id_permission __PERMISSION_GET;

    profiled 1;
    
    server_event onbefore
    {
     execute method
     {
      class_name "spreadsheet";
      method_name "etest1";
     };
    };

    server_event onafter
    {
     execute_jscript
     %%
     ap_write("alert('johooo');");
     %%
     ;
    };

    __ACL_HEADER

    declare language
    {
      C
      %%
      int id_entry;
      %%
      ;
    };

    body language_c
    {
      C
      %%
      %%
     ;
    };
  };

  method get
  {
    doc "returns recordset with spreadsheet contents";
    id_permission __PERMISSION_GET;

    __ACL_HEADER
    body language_c
    {
      C
      %%
      __CREATE_QUERY("SELECT C.column_number,R.row_number,CL.value,
                      CL.align,CL.fontsize,CL.textcolor,CL.fontfamily,CL.textstyle,
 		      (SELECT EXPR.expression_parsed from co_%s_expression EXPR WHERE EXPR.id_column=CL.column_id
		      AND EXPR.id_row=CL.row_id)
                      FROM co_%s_spreadsheet_column C, co_%s_spreadsheet_row R, co_%s_spreadsheet_cell CL
                      WHERE C.spreadsheet_id=%d AND C.spreadsheet_id=R.spreadsheet_id AND
                      C.id=CL.column_id AND R.id=CL.row_id
                      ORDER BY R.row_number ASC, C.column_number ASC", par_area, par_area, par_area, par_area, par_id);
      __SQL_GET_RESULT
      __RETURN_RESULT
      %%
      ;
    };
  };

  method edit
  {
    doc "generates main client page (just frame partition)";
    id_permission __PERMISSION_GET;

    __ACL_HEADER
    body language_c
    {
     C
     %%
     __CREATE_QUERY("SELECT id FROM co_%s_spreadsheet WHERE id=%d",par_area,par_id)
     __SQL_GET_RESULT
     __CLEAR_RESULT

     if (ok)
     {
		cou_putsBODY( cnx, 
			"<FRAMESET ROWS='120,*' FRAMEBORDER=NO FRAMESPACING=0>\n");
       ap_rprintf(r,"<FRAME NAME=f_value SCROLLING=no SRC='spreadsheet?editTop&par_area=%s&par_class=%s&par_id=%d&debug_level=%d'>\n",par_area,par_class,par_id,cnx->debug_level);
       ap_rprintf(r,"<FRAME NAME=f_spreadsheet SRC='spreadsheet?editBottom&par_area=%s&par_class=%s&par_id=%d&debug_level=%d'>\n",par_area,par_class,par_id,cnx->debug_level);
       ap_rputs("</FRAMESET>\n",r);
		cou_finishHTML(cnx);
     }
     else {
		cou_putsBODY( cnx, 
			"<BODY><H3>requested object does not exist</H3></BODY>");
		cou_finishHTML(cnx);
	}
     %%
     ;
    };
  };

  method editTop
  {
    doc "generates top (value, style buttons, controls) frame for spreadsheet client interface";
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    declare language_c
    {
     C
     %%
     FILE *fh;
     char *filename;
     %%
     ;
    };

    body language_c
    {
     C
     %%
     ap_rprintf(r,"<SCRIPT>var par_id=%d;</SCRIPT>\n",par_id);
     filename = ap_psprintf(p, "%s/spreadsheet/editTop", cou_getCORootPath(cnx));
     __PUT_HTML_FROM_FILE(filename)
     %%
     ;
    };
  };

  method editBottom
  {
    doc "generates bottom(with spreadsheet data) frame for client interface";
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    declare language_c
    {
     C
     %%
     int cols; // number of columns
     int rows; // number of rows
     int i,j,pos; // iteration variables
     char textstyle[3]; // texstyle property (bold,italic,underline)
     char column_abr[3]; // column abreviation A,B,..
     char *cell_value; // as the name says
     char *filename;
     FILE *fh;
     co_recordset * corec2;
     co_typein_getCellRefs *in_params;
     %%
     ;
    };

    body language_c
    {
     C
     %%
     ap_rprintf(r,"<HEAD>\n<SCRIPT>\nvar par_id=%d;\nvar id_session=%d;\nvar par_area='%s'\nvar debug_level=%d\n</SCRIPT>\n",par_id,cou_assignNewSession(cnx), par_area, cnx->debug_level);

     filename = ap_psprintf(p, "%s/spreadsheet/editBottom.head", cou_getCORootPath(cnx));

     __PUT_HTML_FROM_FILE(filename)

     ap_rputs("</HEAD>\n",r);

     filename = ap_psprintf(p, "%s/spreadsheet/editBottom.body", cou_getCORootPath(cnx));

     __PUT_HTML_FROM_FILE(filename)

     // here we ought to generate spreadsheet
     ap_rputs("<TABLE id=table BORDER=5",r);
     ap_rputs(" LANGUAGE=javascript onkeyup='body_onkeyup()' onclick='return table_onclick()'",r);
     ap_rputs(" ondblclick='table_ondblclick()' onmouseup='table_onmouseup()'",r);
     ap_rputs(" onselectstart='return table_onselectstart()' onmouseover='return table_onmouseover()'",r);
     ap_rputs(">\n",r);

     // obtain column ids
     __CREATE_QUERY("SELECT id,align,fontsize,textcolor,fontfamily,textstyle,name FROM co_%s_spreadsheet_column WHERE spreadsheet_id=%d ORDER BY column_number",par_area,par_id);
     __SQL_GET_RESULT
     cols = cor_GetTupleCount(cnx, corec);

     // column attributes

     ap_rputs("<COL width=30 align=center>\n",r);
     ap_rputs("<COLGROUP id=columns width=100>\n",r);
     for (i=0;i<cols;i++)
     {
      ap_rputs("<COL ",r);
      if (strcmp(cor_GetValue(cnx, corec,i,1),"")) ap_rprintf(r," align=%s",cor_GetValue(cnx, corec,i,1));
      ap_rputs(" style='",r);
      if (strcmp(cor_GetValue(cnx, corec,i,3),"")) ap_rprintf(r,"color:%s",cor_GetValue(cnx, corec,i,3));
      if (strcmp(cor_GetValue(cnx, corec,i,4),"")) ap_rprintf(r,";font-family:%s",cor_GetValue(cnx, corec,i,4));
      if (strcmp(cor_GetValue(cnx, corec,i,2),"")) ap_rprintf(r,";font-size:%s",cor_GetValue(cnx, corec,i,2));
      strncpy(textstyle,cor_GetValue(cnx, corec,i,5),3);
      if (textstyle[0]=='B') ap_rputs(";font-weight:700",r);
      if (textstyle[1]=='I') ap_rputs(";font-style:italic",r);
      if (textstyle[2]=='U') ap_rputs(";text-decoration:underline",r);
      ap_rprintf(r,"'");
      if (strcmp(cor_GetValue(cnx, corec,i,6),"")) ap_rprintf(r," NAMED=1");
      ap_rprintf(r," DB_ID=%s>\n",cor_GetValue(cnx, corec,i,0));
     }
     ap_rputs("</COLGROUP>\n",r);

     // first row with column names ...
     ap_rputs("<TR bgcolor=LightGrey align=center>\n<TD onclick='select_all()' id='ST'></TD>\n",r);
     for (i=0;i<cols;i++)
     {
      ap_rprintf(r,"<TD id=%d bgcolor=F0F0F0 style='font-family:verdana' align=center",i+1);
      if (strcmp(cor_GetValue(cnx, corec,i,6),"")) ap_rprintf(r,">%s",cor_GetValue(cnx, corec,i,6));
      else
      {
       j = i;
       pos = 0;
       // 26 is number of characters in english alphabet
       while (j>=26)
       {
       // 65 is an ASCI code for first letter of an alphabet
         column_abr[pos++] = (char) (65+(j % 26));
         j /= 26; j--;
       }
       column_abr[pos] = (char) (65+j);

       ap_rputs(">",r);
       while (pos>=0) ap_rprintf(r,"%c",column_abr[pos--]);
      }
      ap_rputs("</TD>\n",r);
     }
     __CLEAR_RESULT

     ap_rputs("<TD bgcolor=black><INPUT type=button style='HEIGHT: 23px;WIDTH: 16px' value='+' onclick='add_column()'",r);
     ap_rputs(" id=button1 name=button1></TD>\n</TR>\n",r);

     // read spreadsheet data from database

     @co_call(par_area, par_class,"get", par_area=>par_area, par_class=>par_class, par_id=>par_id);
     __GET_RETURNED_RECORDSET( corec)

     // obtain row attributes
     __CREATE_QUERY("SELECT id,align,fontsize,textcolor,fontfamily,textstyle,name FROM co_%s_spreadsheet_row WHERE spreadsheet_id=%d ORDER BY row_number", par_area, par_id);
     __SQL_GET_VRESULT(corec2)
     rows = cor_GetTupleCount(cnx, corec2);

     // translate data into HTML
     pos = 0;
     for (i=1;i<=rows;i++)
     {
      // row style
      ap_rputs("<TR bgcolor=white",r);
      if (strcmp(cor_GetValue(cnx, corec2,i-1,1),"")) ap_rprintf(r," align=%s",cor_GetValue(cnx, corec2,i-1,1));
      ap_rputs(" style='",r);
      if (strcmp(cor_GetValue(cnx, corec2,i-1,3),"")) ap_rprintf(r,"color:%s",cor_GetValue(cnx, corec2,i-1,3));
      if (strcmp(cor_GetValue(cnx, corec2,i-1,4),"")) ap_rprintf(r,";font-family:%s",cor_GetValue(cnx, corec2,i-1,4));
      if (strcmp(cor_GetValue(cnx, corec2,i-1,2),"")) ap_rprintf(r,";font-size:%s",cor_GetValue(cnx, corec2,i-1,2));

      strncpy(textstyle,cor_GetValue(cnx, corec2,i-1,5),3);
      if (textstyle[0]=='B') ap_rputs(";font-weight:700",r);
      if (textstyle[1]=='I') ap_rputs(";font-style:italic",r);
      if (textstyle[2]=='U') ap_rputs(";text-decoration:underline",r);

      if (!strcmp("",cor_GetValue(cnx, corec2,i-1,6))) 
      {
        // column obtains default name
        ap_rprintf(r,"' bordercolor=MistyRose DB_ID=%s>\n<TD bgcolor=F0F0F0 style='font-family:verdana' id=%d>%d</TD>\n",cor_GetValue(cnx, corec2,i-1,0),i,i);
      }
      else
      {
        // column obtains defined name
        ap_rprintf(r,"' bordercolor=MistyRose DB_ID=%s NAMED=1>\n<TD bgcolor=F0F0F0 style='font-family:verdana' id=%d>%s</TD>\n",cor_GetValue(cnx, corec2,i-1,0),i,cor_GetValue(cnx, corec2,i-1,6));
      }

      for (j=1;j<=cols;j++)
      {
       if (pos==cor_GetTupleCount(cnx, corec)) ap_rputs("<TD TYP='STR'>.</TD>\n",r);
       else
       {
        if ((i==atoi(cor_GetValue(cnx, corec,pos,1))) && (j==atoi(cor_GetValue(cnx, corec,pos,0))))
	{
	 ap_rputs("<TD TYP='STR'",r);
	 ap_rprintf(r," EXPR='%s'", cou_buildEncodedHTMLForScript( cnx, cor_GetValue(cnx, corec,pos,8)));

	 if (strcmp(cor_GetValue(cnx, corec,pos,3),"")) ap_rprintf(r," align=%s",cor_GetValue(cnx, corec,pos,3));

	 ap_rputs(" style='",r);
	 if (strcmp(cor_GetValue(cnx, corec,pos,5),"")) ap_rprintf(r,"color:%s",cor_GetValue(cnx, corec,pos,5));
	 if (strcmp(cor_GetValue(cnx, corec,pos,6),"")) ap_rprintf(r,";font-family:%s",cor_GetValue(cnx, corec,pos,6));
	 if (strcmp(cor_GetValue(cnx, corec,pos,4),"")) ap_rprintf(r,";font-size:%s",cor_GetValue(cnx, corec,pos,4));

	 strncpy(textstyle,cor_GetValue(cnx, corec,pos,7),3);
	 if (textstyle[0]=='B') ap_rputs(";font-weight:700",r);
	 if (textstyle[1]=='I') ap_rputs(";font-style:italic",r);
	 if (textstyle[2]=='U') ap_rputs(";text-decoration:underline",r);

	 cell_value = ap_escape_html(p, cor_GetValue(cnx, corec,pos,2));
	 if (strcmp(cell_value,"")) ap_rprintf(r,"'>%s</TD>\n",cell_value);
	 else ap_rputs("'>.</TD>\n",r);

	 pos++;
	}
        else ap_rputs("<TD TYP='STR'>.</TD>\n",r);
       }
      }
      ap_rputs("</TR>\n",r);
     }
     ap_rputs("<TR>\n<TD bgcolor=black><INPUT type=button value='+'",r);
     ap_rputs(" onclick='add_row()' id=button2 name=button2></TD>\n</TR>\n",r);
     ap_rputs("</TABLE>\n<SCRIPT>\n",r);

     @co_call(par_area, '"expression"',"getCellRefs", par_area=>par_area, par_class=>'"expression"', par_id=>par_id);

     ap_rputs("</SCRIPT>\n<SPAN id=inserter></SPAN></BODY>",r);

     __CLEAR_RESULT
     cor_Clear(cnx, corec2);
     %%
     ;
    };
  };

  method toHTML
  {
    doc "generates static spreadsheet, returns string with HTML";
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    declare language_c
    {
     C
     %%
     int cols; // number of columns
     int rows; // number of rows
     int i,j,pos; // iteration variables
     char textstyle[3]; // texstyle property (bold,italic,underline)
     char column_abr[3]; // column abreviation A,B,..
     char *cell_value; // as the name says
     char *filename;
     FILE *fh;
     co_recordset * corec2;
     co_typein_getCellRefs *in_params;
     co_string * HTMLResult;
     %%
     ;
    };

    body language_c
    {
     C
     %%
     HTMLResult = cos_CreateEmpty(cnx);
     
     cos_AppendString(cnx, HTMLResult, "<TABLE id=table BORDER=5>\n");

     // obtain column ids
     __CREATE_QUERY("SELECT id,align,fontsize,textcolor,fontfamily,textstyle,name FROM co_%s_spreadsheet_column WHERE spreadsheet_id=%d ORDER BY column_number",par_area,par_id);
     __SQL_GET_RESULT
     cols = cor_GetTupleCount(cnx, corec);

     // column attributes

     cos_AppendString(cnx, HTMLResult, "<COL width=30 align=center>\n");
     cos_AppendString(cnx, HTMLResult, "<COLGROUP width=100>\n");
     for (i=0;i<cols;i++)
     {
      cos_AppendString(cnx, HTMLResult, "<COL ");
      if (strcmp(cor_GetValue(cnx, corec,i,1),"")) cos_AppendFormatted(cnx, HTMLResult, " align=%s", cor_GetValue(cnx, corec,i,1));
      cos_AppendString(cnx, HTMLResult, " style='");
      if (strcmp(cor_GetValue(cnx, corec,i,3),"")) cos_AppendFormatted(cnx, HTMLResult, "color:%s", cor_GetValue(cnx, corec,i,3));
      if (strcmp(cor_GetValue(cnx, corec,i,4),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-family:%s", cor_GetValue(cnx, corec,i,4));
      if (strcmp(cor_GetValue(cnx, corec,i,2),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-size:%s", cor_GetValue(cnx, corec,i,2));
      strncpy(textstyle,cor_GetValue(cnx, corec,i,5),3);
      if (textstyle[0]=='B') cos_AppendString(cnx, HTMLResult, ";font-weight:700");
      if (textstyle[1]=='I') cos_AppendString(cnx, HTMLResult, ";font-style:italic");
      if (textstyle[2]=='U') cos_AppendString(cnx, HTMLResult, ";text-decoration:underline");
      cos_AppendString(cnx, HTMLResult, "' >\n");
     }
     cos_AppendString(cnx, HTMLResult, "</COLGROUP>\n");

     // first row with column names ...
     cos_AppendString(cnx, HTMLResult, "<TR bgcolor=LightGrey align=center>\n<TD></TD>\n");
     for (i=0;i<cols;i++)
     {
      cos_AppendString(cnx, HTMLResult, "<TD bgcolor=F0F0F0 style='font-family:verdana' align=center");
      if (strcmp(cor_GetValue(cnx, corec,i,6),"")) cos_AppendFormatted(cnx, HTMLResult, ">%s", cor_GetValue(cnx, corec,i,6));
      else
      {
       j = i;
       pos = 0;
       // 26 is number of characters in english alphabet
       while (j>=26)
       {
       // 65 is an ASCI code for first letter of an alphabet
         column_abr[pos++] = (char) (65+(j % 26));
         j /= 26; j--;
       }
       column_abr[pos] = (char) (65+j);

       cos_AppendString(cnx, HTMLResult, ">");
       while (pos>=0) cos_AppendFormatted(cnx, HTMLResult, "%c", column_abr[pos--]);
      }
      cos_AppendString(cnx, HTMLResult, "</TD>\n");
     }
     __CLEAR_RESULT

     cos_AppendString(cnx, HTMLResult, "</TR>\n");

     // read spreadsheet data from database

     @co_call(par_area, par_class,"get", par_area=>par_area, par_class=>par_class, par_id=>par_id);
     __GET_RETURNED_RECORDSET( corec)

     // obtain row attributes
     __CREATE_QUERY("SELECT id,align,fontsize,textcolor,fontfamily,textstyle,name FROM co_%s_spreadsheet_row WHERE spreadsheet_id=%d ORDER BY row_number", par_area, par_id);
     __SQL_GET_VRESULT(corec2)
     rows = cor_GetTupleCount(cnx, corec2);

     // translate data into HTML
     pos = 0;
     for (i=1;i<=rows;i++)
     {
      // row style
      cos_AppendString(cnx, HTMLResult, "<TR bgcolor=white");
      if (strcmp(cor_GetValue(cnx, corec2,i-1,1),"")) cos_AppendFormatted(cnx, HTMLResult, " align=%s", cor_GetValue(cnx, corec2,i-1,1)); 
      cos_AppendString(cnx, HTMLResult, " style='");
      if (strcmp(cor_GetValue(cnx, corec2,i-1,3),"")) cos_AppendFormatted(cnx, HTMLResult, "color:%s", cor_GetValue(cnx, corec2,i-1,3));
      if (strcmp(cor_GetValue(cnx, corec2,i-1,4),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-family:%s", cor_GetValue(cnx, corec2,i-1,4));
      if (strcmp(cor_GetValue(cnx, corec2,i-1,2),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-size:%s",cor_GetValue(cnx, corec2,i-1,2));

      strncpy(textstyle,cor_GetValue(cnx, corec2,i-1,5),3);
      if (textstyle[0]=='B') cos_AppendString(cnx, HTMLResult, ";font-weight:700");
      if (textstyle[1]=='I') cos_AppendString(cnx, HTMLResult, ";font-style:italic");
      if (textstyle[2]=='U') cos_AppendString(cnx, HTMLResult, ";text-decoration:underline");

      if (!strcmp("",cor_GetValue(cnx, corec2,i-1,6))) 
      {
        // column obtains default name
        cos_AppendFormatted(cnx, HTMLResult, "' bordercolor=MistyRose>\n<TD bgcolor=F0F0F0 style='font-family:verdana'>%d</TD>\n",i);
      }
      else
      {
        // column obtains defined name
        cos_AppendFormatted(cnx, HTMLResult, "' bordercolor=MistyRose>\n<TD bgcolor=F0F0F0 style='font-family:verdana'>%s</TD>\n", cor_GetValue(cnx, corec2,i-1,6));
      }

      for (j=1;j<=cols;j++)
      {
       if (pos==cor_GetTupleCount(cnx, corec)) cos_AppendString(cnx, HTMLResult, "<TD>.</TD>\n");
       else
       {
        if ((i==atoi(cor_GetValue(cnx, corec,pos,1))) && (j==atoi(cor_GetValue(cnx, corec,pos,0))))
	{
	 cos_AppendString(cnx, HTMLResult, "<TD");

	 if (strcmp(cor_GetValue(cnx, corec,pos,3),"")) cos_AppendFormatted(cnx, HTMLResult, " align=%s", cor_GetValue(cnx, corec,pos,3));

	 cos_AppendString(cnx, HTMLResult, " style='");
	 if (strcmp(cor_GetValue(cnx, corec,pos,5),"")) cos_AppendFormatted(cnx, HTMLResult, "color:%s", cor_GetValue(cnx, corec,pos,5));
	 if (strcmp(cor_GetValue(cnx, corec,pos,6),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-family:%s", cor_GetValue(cnx, corec,pos,6));
	 if (strcmp(cor_GetValue(cnx, corec,pos,4),"")) cos_AppendFormatted(cnx, HTMLResult, ";font-size:%s", cor_GetValue(cnx, corec,pos,4));

	 strncpy(textstyle,cor_GetValue(cnx, corec,pos,7),3);
	 if (textstyle[0]=='B') cos_AppendString(cnx, HTMLResult, ";font-weight:700");
	 if (textstyle[1]=='I') cos_AppendString(cnx, HTMLResult, ";font-style:italic");
	 if (textstyle[2]=='U') cos_AppendString(cnx, HTMLResult, ";text-decoration:underline");

	 cell_value = ap_escape_html(p, cor_GetValue(cnx, corec,pos,2));
	 if (strcmp(cell_value,"")) cos_AppendFormatted(cnx, HTMLResult, "'>%s</TD>\n", cell_value);
	 else cos_AppendString(cnx, HTMLResult, "'>.</TD>\n");
	 pos++;
	}
        else cos_AppendString(cnx, HTMLResult, "<TD>.</TD>\n");
       }
      }
      cos_AppendString(cnx, HTMLResult, "</TR>\n");
     }
     cos_AppendString(cnx, HTMLResult, "</TABLE>\n");

     __CLEAR_RESULT
     cor_Clear(cnx, corec2);
     
     __RETURN_STRING(cos_GetSimplifiedString(cnx, HTMLResult))
     %%
     ;
    };
  };

  method view
  {
    doc "generates static spreadsheet, as a HTML page";
    id_permission __PERMISSION_GET;

    __ACL_HEADER

    declare language_c
    {
     C
     %%
     char * strHTML;
     %%
     ;
    };

    body language_c
    {
     C
     %%
     ap_rputs("<BODY>\n",r);
     @co_call(par_area, par_class,"toHTML", par_area=>par_area, par_class=>par_class, par_id=>par_id);
     __GET_RETURNED_STRING(strHTML)
     ap_rputs(strHTML,r);
     ap_rputs("</BODY>",r);
     %%
     ;
    };
  };

  method create
  {
    doc "overrides generic_acl::create methods, creates new spreadsheet structures";
    id_permission __PERMISSION_CREATE;
    sec_type __METHOD_SEC_TYPE_CLASS;

#include "../../include/create_header.t"

    declare language_c
    {
     C
     %%
     int i;
     int new_id;

     const char *name = "";
     const char *str_cols = "";
     const char *str_rows = "";

     int cols = 1;
     int rows = 1;
     int pos;
     int NParams = 0;

     int check_security;
     %%
     ;
    };

    body language_c
    {
     C
     %%

// obtain parameters from create_params
     NParams = coa_GetElementCount(cnx, create_params);
     for(pos = 0; pos<NParams; pos+=2)
     {
      if (!strcmp(coa_GetElement(cnx, create_params, pos),"name"))    name     = ap_pstrdup(p, coa_GetElement(cnx,create_params, pos+1));
      if (!strcmp(coa_GetElement(cnx, create_params, pos),"columns")) str_cols = ap_pstrdup(p, coa_GetElement(cnx,create_params, pos+1));
      if (!strcmp(coa_GetElement(cnx, create_params, pos),"rows"))    str_rows = ap_pstrdup(p, coa_GetElement(cnx,create_params, pos+1));
     }

     cols = strtol(str_cols, NULL, 10);
     rows = strtol(str_rows, NULL, 10);

     if(cols < 1) cols = 1;
     if(rows < 1) rows = 1;

     if(rows > 200)
     {
       rows = 200;
       cou_sendMessageX(cnx, "Maksymalnie moesz poda 200 dla iloci wierszy", CO_MSG_FORCE);
     }

     if(cols > 200)
     {
       cols = 200;
       cou_sendMessageX(cnx, "Maksymalnie moesz poda 200 dla iloci kolumn", CO_MSG_FORCE);
     }

     // create spreadsheet

     @co_call(par_area,'"generic_acl"',"create",par_area=>par_area,par_class=>'"spreadsheet"',par_id=>-1,dont_set_acl=>dont_set_acl);

     __GET_RETURNED_INTEGER(new_id)

     check_security = cnx->check_security;
     cnx->check_security = 0;
     @co_call(par_area,par_class,"update",par_area=>par_area,par_class=>'"spreadsheet"',version=>0,par_id=>new_id,par_prop=>'"name"',new_value=>name);
     cnx->check_security = check_security;
     
     // create rows
     for (i=0;i<rows;i++)
     {
      __CREATE_QUERY("INSERT INTO co_%s_spreadsheet_row(row_number,spreadsheet_id) VALUES(%d,%d)",par_area,i+1,new_id)
      __SQL_EXEC
     }

     // create columns
     for (i=0;i<cols;i++)
     {
      __CREATE_QUERY("INSERT INTO co_%s_spreadsheet_column(column_number,spreadsheet_id) VALUES(%d,%d)",par_area,i+1,new_id)
      __SQL_EXEC
     }

     __RETURN_INTEGER( new_id)
     
     %%
     ;
    };
  };

  method setEventHandler
    {
        doc "as the name says";
        id_permission __PERMISSION_INSERT_CHILD;

	__ACL_HEADER
	param column_id { type CO_INTEGER; };
	param row_id { type CO_INTEGER; };
	param event_name { type CO_STRING; };
	param event_script { type CO_STRING_SQL_VALUE; };

	body language_c
	{
          C
          %%

/* TODO: SQL encoding */

	  __CREATE_QUERY("
	  UPDATE co_%s_js_code
	  SET code='%s'
	  FROM co_%s_spreadsheet_cevent
	  WHERE spreadsheet_id=%d AND column_id=%d AND row_id=%d
	  AND event_type_id=
	  (SELECT id FROM co_%s_cevent_type WHERE type='%s')
	  AND co_sys_js_code.id=id_js_code
	  ",par_area,event_script,par_area,par_id,column_id,row_id,par_area,event_name)
	  __SQL_EXEC

	  if (!ok)
	  {
	   __CREATE_QUERY("
	   INSERT INTO co_%s_js_code (code) VALUES ('%s');
	   INSERT INTO co_%s_spreadsheet_cevent
	   (event_type_id,spreadsheet_id,column_id,row_id,id_js_code)
	   VALUES(
	   (SELECT id FROM co_%s_cevent_type WHERE type='%s'),
	    %d,%d,%d,co_%s_js_code_sqid.last_value)
	    ",par_area,event_script,par_area,par_area,event_name,par_id,column_id,row_id,par_area)
	   __SQL_EXEC
	  }
	  %%
	  ;
        };
    };

    method getDefinedEvents
    {
      doc "used by spreadsheet client interface to obtain all defined events";
      doc "just binary values no event code sent";
      id_permission __PERMISSION_GET_RELATED;

      __ACL_HEADER

      declare language_c
      {
        C
	%%
	char *callback;
	%%
	;
      };
      
      body language_c
      {
        C
	%%
	// here we should gather events info
	__CREATE_QUERY("
	SELECT ET.type,
	(SELECT C.column_number FROM co_%s_spreadsheet_column C WHERE C.id=E.column_id) AS column_number,
	(SELECT R.row_number FROM co_%s_spreadsheet_row R WHERE R.id=E.row_id) AS row_number
	FROM co_%s_spreadsheet_cevent E, co_%s_cevent_type ET
	WHERE (E.event_type_id=ET.id) AND (E.spreadsheet_id=%d)",par_area,par_area,par_area,par_area,par_id)
	callback = ap_pstrdup(p,"client_assignEvents(");
	__GET_RESULT_AND_CREATE_JS
	%%
	;
      };
    };

  method onEvent
  {
    doc "event occured";
    id_permission __PERMISSION_EVALUATE;

    __ACL_HEADER
    param column_id { type CO_INTEGER; };
    param row_id { type CO_INTEGER; };
    param event_name { type CO_STRING; };

    declare language_c
    {
      C
      %%
	int id_js_code = 0;
	const char* prolog;
      %%
      ;
    };

    body language_c
      {
        C
        %%

        __SQL_GET_INTEGER(id_js_code,"
        SELECT E.id_js_code FROM co_%s_spreadsheet_cevent E,
                           co_%s_cevent_type ET
        WHERE (E.event_type_id=ET.id)
        AND (E.spreadsheet_id=%d)
	AND (E.column_id=%d OR E.column_id=0)
	AND (E.row_id=%d OR E.row_id=0)
        AND (ET.type='%s')
        ORDER BY E.row_id DESC,E.column_id DESC",par_area,par_area,par_id,column_id,row_id,event_name);

	if (ok)
	{
	  prolog = ap_psprintf( p,
	  "var context = new Object();\n"
	  "context.id_spreadsheet=%d;\ncontext.id_column=%d;\ncontext.id_row=%d;\n",
	  par_id, column_id, row_id);

          @co_call(par_area,'"js_code"','evaluate',par_area=>par_area,par_class=>'"js_code"',par_id=>id_js_code,prolog=>prolog,asp=>0);
	}  
	%%
        ;
      };
  };

  method getAllRowIds
  {
    doc "returns recordset with row ids for a given spreadsheet (row_number order)";
    id_permission __PERMISSION_GET_RELATED;

    __ACL_HEADER

    body language_c
      {
        C
        %%

        __CREATE_QUERY( "
	select id from co_%s_spreadsheet_row
	where spreadsheet_id=%d and deleted=0
	order by row_number;
	",par_area,par_id)

        __SQL_GET_RESULT
	__RETURN_RESULT

        %%
        ;
      };
  };

  method getAllColumnIds
  {
    doc "returns recordset with column ids for a given spreadsheet (column_number order)";
    id_permission __PERMISSION_GET_RELATED;

    __ACL_HEADER

    body language_c
      {
        C
        %%                                                             

        __CREATE_QUERY( "
	select id, name from co_%s_spreadsheet_column
	where spreadsheet_id=%d and deleted=0
	order by column_number;
	",par_area,par_id)

        __SQL_GET_RESULT

	__RETURN_RESULT

        %%
        ;
      };
  };
};

//END OF CLASS spreadsheet