// TYPES FOR CO

#include "types.t"      
#include "defines.t"


// CLASS spreadsheet_column

class spreadsheet_column
{ 
  area sys;

#include "check_iacl.t"

  container_class 'spreadsheet';
  container_column_name 'spreadsheet_id';

  inherits generic_iacl;
  
#include "generic_iacl_props.t"

  uses "spreadsheet";

  include_c "http_protocol.h";
  include_c "co_session.h";
  include_c "../coffice/co_broker.h";

 // PROPERTIES

  index cn
  {
    unique 0;
    column column_number;
  };

  prop column_number
  {
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop length
  {
   f_body
   %%
   select max(row_number) from co_sys_spreadsheet_row where spreadsheet_id=($1.spreadsheet_id);
   %%
   ;
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop spreadsheet_id
  {
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign 'spreadsheet';
   foreign_prop 'id';
   position 44;
  };

  prop name
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop align
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop fontsize
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop textstyle
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop textcolor
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop fontfamily
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

 // METHODS
  
  method insertBeforeColumn
  {
    doc "creates new column and insert before given";
    id_permission __PERMISSION_CREATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER

    declare language_c
    {
     C
     %%
     const char* puta_classes[] = { "spreadsheet", "spreadsheet_column", NULL};
     int puta_ids[] = { 0, 0}; // for queueActionX

     int colToInsert_num; // numer of new column
     int colInserted_id;  // id of already inserted column
     int spreadsheet_id;
     %%
     ;
    };

    body language_c
      {
        C
	%%
	// calculate colToInsert_num
	__CREATE_QUERY("SELECT column_number,spreadsheet_id FROM co_%s_spreadsheet_column WHERE id=%d", par_area, par_id);
	__SQL_GET_RESULT
	colToInsert_num = atoi(cor_GetValue(cnx, corec,0,0));
	spreadsheet_id =  atoi(cor_GetValue(cnx, corec,0,1));
	__CLEAR_RESULT
	// shift after-columns
	__CREATE_QUERY("UPDATE co_%s_spreadsheet_column SET
			column_number=column_number+1 WHERE
			column_number>=%d AND spreadsheet_id=%d", par_area, colToInsert_num, spreadsheet_id);
	__SQL_EXEC
	// now insert column
	__CREATE_QUERY("INSERT INTO co_%s_spreadsheet_column(column_number,spreadsheet_id)
			VALUES(%d,%d)", par_area, colToInsert_num, spreadsheet_id);
	__SQL_EXEC

	// calculate colInserted_id
	__SQL_GET_INTEGER(colInserted_id,"SELECT id FROM co_%s_spreadsheet_column WHERE
			column_number=%d AND spreadsheet_id=%d", par_area, colToInsert_num, spreadsheet_id)

	sprintf(JSOutBuf,"%d",colToInsert_num);
	puta_ids[0] = spreadsheet_id; puta_ids[1] = colInserted_id;
        cou_queueActionX( cnx, "spreadsheet_column", puta_classes, puta_ids, CO_OP_INSERT, "number", JSOutBuf, NULL);

	@co_call(par_area,'"spreadsheet"',"onEvent",par_id=>spreadsheet_id,column_id=>par_id,row_id=>0,event_name=>'"onaddcolumn"');
	%%
	;
      };
  };

  method insertAfterColumn
  {
    doc "creates new column and insert after given";
    id_permission __PERMISSION_CREATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER

    declare language_c
    {
     C
     %%
     const char* puta_classes[] = { "spreadsheet", "spreadsheet_column", NULL};
     int puta_ids[] = { 0, 0}; // for queueActionX

     int colToInsert_num; // numer of new column
     int colInserted_id;  // id of already inserted column
     int spreadsheet_id;
     %%
     ;
    };

    body language_c
      {
        C
	%%
	//calculate colToInsert_num
	__CREATE_QUERY("SELECT column_number,spreadsheet_id FROM co_%s_spreadsheet_column WHERE id=%d", par_area, par_id);
	__SQL_GET_RESULT
	colToInsert_num = atoi(cor_GetValue(cnx, corec,0,0))+1;
	spreadsheet_id =  atoi(cor_GetValue(cnx, corec,0,1));
	__CLEAR_RESULT
	
	// shift after-columns
	__CREATE_QUERY("UPDATE co_%s_spreadsheet_column SET
			column_number=column_number+1 WHERE
			column_number>=%d AND spreadsheet_id=%d", par_area, colToInsert_num, spreadsheet_id);
	__SQL_EXEC
	// now insert column
	__CREATE_QUERY("INSERT INTO co_%s_spreadsheet_column(column_number,spreadsheet_id)
			VALUES(%d,%d)", par_area, colToInsert_num, spreadsheet_id);
	__SQL_EXEC
        
	// calculate colInserted_id
	__SQL_GET_INTEGER(colInserted_id,"SELECT id FROM co_%s_spreadsheet_column WHERE
			column_number=%d AND spreadsheet_id=%d", par_area, colToInsert_num, spreadsheet_id)

	sprintf(JSOutBuf,"%d",colToInsert_num);
	puta_ids[0] = spreadsheet_id; puta_ids[1] = colInserted_id;
        cou_queueActionX( cnx, "spreadsheet_column", puta_classes, puta_ids, CO_OP_INSERT, "number", JSOutBuf, NULL);

	@co_call(par_area,'"spreadsheet"',"onEvent",par_id=>spreadsheet_id,column_id=>par_id,row_id=>0,event_name=>'"onaddcolumn"');
	%%
	;
      };
  };


  method delete
  {
   doc "deletes column";
   id_permission __PERMISSION_DELETE;
   sec_type __METHOD_SEC_TYPE_OBJECT;

   __PARAMS_HEADER_WITH_VERSION
  
   declare language_c
   {
    // number of column to delete
    C 
    %%
     const char* puta_classes[] = { "spreadsheet", "spreadsheet_column", NULL};
     int puta_ids[] = { 0, 0}; // for queueActionX
     
     int col_num;
     int col_id;
    %%
    ;
   };

   body language_c
   {
    C
    %%
	col_id=par_id; /* replace in code: col_id->par_id */
    __SQL_GET_INTEGER(col_num,"SELECT column_number FROM co_%s_spreadsheet_column WHERE id=%d", par_area, col_id)
    __CREATE_QUERY("DELETE FROM co_%s_spreadsheet_column WHERE id=%d", par_area, col_id);
    __SQL_EXEC
    __CREATE_QUERY("UPDATE co_%s_spreadsheet_column SET column_number=column_number-1
		    WHERE column_number>%d AND spreadsheet_id=%d", par_area, col_num, par_id);
    __SQL_EXEC
    __CREATE_QUERY("DELETE FROM co_%s_spreadsheet_cell WHERE column_id=%d", par_area, col_id);
    __SQL_EXEC
    // what about events

    puta_ids[0] = par_id; puta_ids[1] = col_id;
    cou_queueActionX( cnx, "spreadsheet_column", puta_classes, puta_ids, CO_OP_DELETE, NULL);
    %%
    ;
   };
  };

  method setAttribute
  {
    doc "changes column attribute";
    id_permission __PERMISSION_UPDATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER
    param column_id { type CO_INTEGER; };
    param attribute_name { type CO_STRING; };
    param attribute_value { type CO_STRING_SQL_VALUE; };
    
    declare language_c
    {
     C
     %%
      const char* puta_classes[] = { "spreadsheet", "spreadsheet_column", NULL};
      int puta_ids[] = { 0, 0}; // for queueActionX

      int column_num; // number of updated column
     %%
     ;
    };

    body language_c
    {
     C
     %%
     __CREATE_QUERY("UPDATE co_%s_spreadsheet_column SET %s='%s' WHERE id=%d", par_area, attribute_name, attribute_value, column_id);
     __SQL_EXEC

     puta_ids[0] = par_id; puta_ids[1] = column_id;
     cou_queueActionX( cnx, "spreadsheet_column", puta_classes, puta_ids, CO_OP_UPDATE, attribute_name, attribute_value, NULL);
     %%
     ;
    };
  };

  method getAttribute
  {
    doc "obtains column attribute";
    id_permission __PERMISSION_GET;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER
    param column_id { type CO_INTEGER; };
    param attribute_name { type CO_STRING; };
    
    declare language_c
    {
     C
     %%
     const char* strValue = "";
     %%
     ;
    };

    body language_c
    {
     C
     %%
     __SQL_GET_STRING(strValue, "SELECT %s FROM co_%s_spreadsheet_column WHERE id=%d",
                      attribute_name, par_area, column_id)
     __RETURN_STRING(strValue)
     %%
     ;
    };
  };

  method getIdByNumber
  {
    doc "Requires object number and id of the container (parent);";
    doc "returns id of the element";
    doc "Does not generate actions.";
    doc "It GET for spreadsheet - but class method because we do not know column id.";
    id_permission __PERMISSION_GET;
    sec_type __METHOD_SEC_TYPE_CLASS;

    __PARAMS_HEADER
    param id_parent { type CO_INTEGER; };
    param number { type CO_INTEGER; };

    declare language_c
    {
     C
     %%
        int id_this; // id of this element

        const char **container_info;
        const char *container_class;
        const char *container_column_name;
     %%
     ;
    };

    body language_c
      {
        C
        %%

        container_info = cou_getContainerInfo( cnx, par_area, par_class);
        container_class = container_info[0];
        container_column_name = container_info[1];

        __SQL_GET_INTEGER(id_this,
            "SELECT id FROM co_%s_%s WHERE %s=%d AND column_number=%d",
            par_area, par_class,
            container_column_name, id_parent, number)
        if (!ok) {
            id_this=0;
        }
        __RETURN_INTEGER(id_this)
        %%
        ;
      };
  };

};
//END OF CLASS spreadsheet_column