// TYPES FOR CO

#include "types.t"
#include "defines.t"


// CLASS spreadsheet_row

class spreadsheet_row
{
  area sys;

#include "check_iacl.t"

  container_class 'spreadsheet';
  container_column_name 'spreadsheet_id';

  inherits generic_iacl;

 // PROPERTIES

#include "generic_props.t"

  uses "spreadsheet";
  uses "expression";
  uses "expression_range";

  include_c "../coffice/co_broker.h";

  index rn
  {
    unique 0;
    column row_number;
  };

  prop row_number
  {
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };
  
  prop length
  {
   f_body
   %%
   select max(column_number) from co_sys_spreadsheet_column where spreadsheet_id=($1.spreadsheet_id);
   %%
   ;
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop spreadsheet_id
  {
   type CO_INTEGER;
   default 0;
   params '';
   representant 1;
   foreign 'spreadsheet';
   foreign_prop 'id';
   position 44;
  };

  prop name
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop align
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop fontsize
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop textstyle
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop textcolor
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  prop fontfamily
  {
   type CO_STRING;
   default "''";
   params '';
   representant 1;
   foreign '';
   foreign_prop '';
   position 44;
  };

  inherits generic_iacl;


 // METHODS

  method insertBeforeRow
  {
    doc "creates new row and inserts before given";
    id_permission __PERMISSION_CREATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER

    declare language_c
    {
     C
     %%
     const char* puta_classes[] = { "spreadsheet", "", "spreadsheet_row", NULL};
     int puta_ids[] = { 0, 0, 0}; // for queueActionX

     int rowToInsert_num; // numer of new row
     int rowInserted_id;  // id of already inserted row
     int spreadsheet_id;
     %%
     ;
    };

    body language_c
      {
        C
	%%
	// calculate rowToInsert_num
	__CREATE_QUERY("SELECT row_number,spreadsheet_id FROM co_%s_spreadsheet_row WHERE id=%d", par_area, par_id);
	__SQL_GET_RESULT
	rowToInsert_num = atoi(cor_GetValue(cnx, corec,0,0));
	spreadsheet_id = atoi(cor_GetValue(cnx, corec,0,1));
	__CLEAR_RESULT
	// shift after-rows
	__CREATE_QUERY("UPDATE co_%s_spreadsheet_row SET
			row_number=row_number+1 WHERE
			row_number>=%d AND spreadsheet_id=%d", par_area, rowToInsert_num, spreadsheet_id);
	__SQL_EXEC
	// now insert row
	__CREATE_QUERY("INSERT INTO co_%s_spreadsheet_row(row_number,spreadsheet_id)
			VALUES(%d,%d)", par_area, rowToInsert_num, spreadsheet_id);
	__SQL_EXEC
	
	// calculate rowInserted_id
	__SQL_GET_INTEGER(rowInserted_id,"SELECT id FROM co_%s_spreadsheet_row WHERE
			row_number=%d AND spreadsheet_id=%d", par_area, rowToInsert_num, spreadsheet_id)

        sprintf(JSOutBuf,"%d",rowToInsert_num); // the only oportunity to use JSOutBuf
	puta_ids[0] = spreadsheet_id; puta_ids[2] = rowInserted_id;
        cou_queueActionX( cnx, "spreadsheet_row", puta_classes, puta_ids, CO_OP_INSERT, "number", JSOutBuf, NULL);

	@co_call(par_area,'"spreadsheet"',"onEvent",par_id=>spreadsheet_id,column_id=>0,row_id=>par_id,event_name=>'"onaddrow"');
	%%
	;
      };
  };

  method insertAfterRow
  {
    doc "creates new row and inserts after given";
    id_permission __PERMISSION_CREATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER

    declare language_c
    {
     C
     %%
     const char* puta_classes[] = { "spreadsheet", "", "spreadsheet_row", NULL};
     int puta_ids[] = { 0, 0, 0}; // for queueActionX

     int rowToInsert_num; // numer of new row
     int rowInserted_id;  // id of already inserted row
     int spreadsheet_id;
     %%
     ;
    };
    body language_c
      {
        C
	%%
	//calculate rowToInsert_num
	__CREATE_QUERY("SELECT row_number,spreadsheet_id FROM co_%s_spreadsheet_row WHERE id=%d", par_area, par_id);
	__SQL_GET_RESULT
	rowToInsert_num = atoi(cor_GetValue(cnx, corec,0,0))+1;
	spreadsheet_id = atoi(cor_GetValue(cnx, corec,0,1));
	__CLEAR_RESULT
	// shift after-rows
	__CREATE_QUERY("UPDATE co_%s_spreadsheet_row SET
			row_number=row_number+1 WHERE
			row_number>=%d AND spreadsheet_id=%d", par_area, rowToInsert_num, spreadsheet_id);
	__SQL_EXEC
	// now insert row
	__CREATE_QUERY("INSERT INTO co_%s_spreadsheet_row(row_number,spreadsheet_id)
			VALUES(%d,%d)", par_area, rowToInsert_num, spreadsheet_id);
	__SQL_EXEC

	// calculate rowInserted_id
	__SQL_GET_INTEGER(rowInserted_id,"SELECT id FROM co_%s_spreadsheet_row WHERE
			row_number=%d AND spreadsheet_id=%d", par_area, rowToInsert_num, spreadsheet_id);

        sprintf(JSOutBuf,"%d",rowToInsert_num); // the only oportunity to use JSOutBuf
	puta_ids[0] = spreadsheet_id; puta_ids[2] = rowInserted_id;
        cou_queueActionX( cnx, "spreadsheet_row", puta_classes, puta_ids, CO_OP_INSERT, "number", JSOutBuf, NULL);

	@co_call(par_area,'"spreadsheet"',"onEvent",par_id=>spreadsheet_id,column_id=>0,row_id=>par_id,event_name=>'"onaddrow"');
	%%
	;
      };
  };

  method delete
  {
   doc "deletes row";
   id_permission __PERMISSION_DELETE;
   sec_type __METHOD_SEC_TYPE_OBJECT;

   __PARAMS_HEADER_WITH_VERSION

   declare language_c
   {
    // number of row to delete
    C
    %%
     const char* puta_classes[] = { "spreadsheet", "", "spreadsheet_row", NULL};
     int puta_ids[] = { 0, 0, 0}; // for queueActionX
     
     int row_num = 0;
     int new_row_id = 0;
     int id_spreadsheet;
    %%
    ;
   };

   body language_c
   {
    C
    %%
    __CREATE_QUERY("SELECT row_number, spreadsheet_id FROM co_%s_spreadsheet_row WHERE id=%d", par_area, par_id)
    __SQL_GET_RESULT
    
    if (ok)
    {
      row_num = atoi(cor_GetValue(cnx,corec,0,0));
      id_spreadsheet = atoi(cor_GetValue(cnx,corec,0,1));
      __CLEAR_RESULT
      __CREATE_QUERY("DELETE FROM co_%s_spreadsheet_row WHERE id=%d", par_area, par_id)
      __SQL_EXEC
      __CREATE_QUERY("UPDATE co_%s_spreadsheet_row SET row_number=row_number-1
  		      WHERE row_number>%d AND spreadsheet_id=%d", par_area, row_num, id_spreadsheet)
      __SQL_EXEC
      __CREATE_QUERY("DELETE FROM co_%s_spreadsheet_cell WHERE row_id=%d", par_area, par_id);
      __SQL_EXEC
      __SQL_GET_INTEGER(new_row_id,
	      "SELECT id FROM co_%s_spreadsheet_row WHERE spreadsheet_id=%d AND row_number=%d",
	      par_area, id_spreadsheet, row_num);
      if (!ok) {
	__SQL_GET_INTEGER(new_row_id,
	      "SELECT id FROM co_%s_spreadsheet_row WHERE spreadsheet_id=%d AND row_number=%d",
	      par_area, id_spreadsheet, row_num-1);
      }

      /* remove expressions from this row */
      @co_call(par_area,'"expression"',"purgeExpressionsInRow",par_area=>par_area,par_class=>'"expression"',par_id=>id_spreadsheet,id_row=>par_id);
      /* update references to point to the new row_num row */
      @co_call(par_area,'"expression_range"',"resetReferencedRow",par_area=>par_area,par_class=>'"expression_range"',par_id=>id_spreadsheet,id_row=>par_id,num_row=>row_num);
      /* eval everything that depends on cells from removed row */
      @co_call(par_area,'"expression"',"evalRectangle", \
	  par_area=>par_area,par_class=>'"expression"',par_id=>id_spreadsheet,id_row=>new_row_id,id_last_row=>new_row_id);

      cou_logError(cnx,CO_LOG_DEBUG,"BEFORE");
      puta_ids[0] = id_spreadsheet; puta_ids[2] = par_id; 
      cou_queueActionX( cnx, "spreadsheet_row", puta_classes, puta_ids, CO_OP_DELETE, NULL);
      cou_logError(cnx,CO_LOG_DEBUG,"AFTER");
    }
    else 
    {
	__CLEAR_RESULT
    }
    %%
    ;
   };
  };

  method setAttribute
  {
    doc "changes row attribute";
    id_permission __PERMISSION_UPDATE;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER
    param row_id { type CO_INTEGER; };
    param attribute_name { type CO_STRING; };
    param attribute_value { type CO_STRING_SQL_VALUE; };
    
    declare language_c
    {
     C
     %%
      const char* puta_classes[] = { "spreadsheet", "", "spreadsheet_row", NULL};
      int puta_ids[] = { 0, 0, 0}; // for queueActionX
      
      int row_num; // number of updated row
     %%
     ;
    };

    body language_c
    {
     C
     %%
     __CREATE_QUERY("UPDATE co_%s_spreadsheet_row SET %s='%s' WHERE id=%d",
                    par_area, attribute_name, attribute_value, row_id)
     __SQL_EXEC 
     
     puta_ids[0] = par_id; puta_ids[1] = row_id;
     cou_queueActionX( cnx, "spreadsheet_row", puta_classes, puta_ids, CO_OP_UPDATE, attribute_name, attribute_value, NULL);
     %%
     ;
    };
  
  };
  
  method getAttribute
  {
    doc "obtains row attribute";
    id_permission __PERMISSION_GET;
    sec_type __METHOD_SEC_TYPE_OBJECT;

    __PARAMS_HEADER
    param row_id { type CO_INTEGER; };
    param attribute_name { type CO_STRING; };
    
    declare language_c
    {
     C
     %%
     const char* strResult = "";
     %%
     ;
    };

    body language_c
    {
     C
     %%
     __SQL_GET_STRING(strResult, "SELECT %s FROM co_%s_spreadsheet_row WHERE id=%d",
                      attribute_name, par_area, row_id)
     __RETURN_STRING(strResult)
     %%
     ;
    };
  };

  method getIdByNumber
  {
    doc "Requires object number and id of the container (parent);";
    doc "returns id of the element";
    doc "Does not generates actions.";
    doc "It GET for spreadsheet - but class method because we do not know row id.";
    id_permission __PERMISSION_GET;
    sec_type __METHOD_SEC_TYPE_CLASS;

    __PARAMS_HEADER
    param id_parent { type CO_INTEGER; };
    param number { type CO_INTEGER; };

    declare language_c
    {
     C
     %%
        int id_this; // id of this element

        const char **container_info;
        const char *container_class;
        const char *container_column_name;
     %%
     ;
    };

    body language_c
      {
        C
        %%

        container_info = cou_getContainerInfo( cnx, par_area, par_class);
        container_class = container_info[0];
        container_column_name = container_info[1];

        __SQL_GET_INTEGER(id_this,
            "SELECT id FROM co_%s_%s WHERE %s=%d AND row_number=%d",
            par_area, par_class,
            container_column_name, id_parent, number)
        if (!ok) {
            id_this=0;
        }
        __RETURN_INTEGER(id_this)
        %%
        ;
      };
  };

};

//END OF CLASS spreadsheet_row