#include "../../include/types.t"
#include "../../include/defines.t"

#define __PARAMS_HEADER2 __PARAMS_HEADER

class start_page
{

   area sec;

#include "../../include/check_acl.t"

   container_class 'role';
   container_column_name 'id';

   default_form "viewTextDocument";

#include "../../include/generic_acl_props.t" 

   uses "text_document";

   prop name
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 200;
   };

   prop file_version
   {
     type CO_INTEGER;
     default 0;
     params '';
     representant 0;
     foreign '';
     foreign_prop '';
     position 250;
   };

   prop description
   {
     type CO_STRING;
     default "''";
     params '';
     representant 1;
     foreign '';
     foreign_prop '';
     position 300;
   };

   prop evaluation_mode
   {
     type CO_STRING;
     default "'HTML'";
     params 'VALUES=new Array("HTML","ASP")';
     representant 1;
     foreign '';
     foreign_prop '';
     position 350;
   };

   inherits text_document;

   include_c "http_protocol.h";

   uses "generic_acl";
   uses "generic";
   uses "file";


   method create
   {
     id_permission __PERMISSION_CREATE;
     sec_type __METHOD_SEC_TYPE_CLASS;

#include "../../include/create_header.t"

     declare language_c
     {
      C
      %%
      int NParams = 0;
      int i;
      int new_id;
      int security_state;
      const char *evalmode = "HTML";
      %%
      ;
     };
 
     body language_c
     {
      C
      %%
      NParams = coa_GetElementCount(cnx, create_params);
      for (i=0;i<NParams;i+=2)
      if (!strcmp(coa_GetElement(cnx, create_params, i),"evaluation_mode"))
        evalmode = ap_pstrdup(p, coa_GetElement(cnx,create_params, i+1));

      @co_call(par_area,'"text_document"',"create",par_area=>par_area,par_class=>par_class,par_id=>-1,create_params=>create_params,dont_set_acl=>dont_set_acl);

      __GET_RETURNED_INTEGER(new_id)
      
      __SEND_MESG_DEBUG("new_id=%d",new_id)
      
      security_state = cnx->check_security;
      cnx->check_security = 0;

      __SEND_MESG_DEBUG("before update")

      @co_call(par_area,par_class,"update",par_area=>par_area,par_class=>par_class,par_id=>new_id,par_prop=>'"evaluation_mode"',new_value=>evalmode,version=>-1);

      __SEND_MESG_DEBUG("after update")

      cnx->check_security = security_state;
      
      __RETURN_INTEGER(new_id)
      
      %%
      ;
     };     


   };

   method getContentType
   {
     id_permission __PERMISSION_GET;
     __PARAMS_HEADER

     body language_c
     {
       C
       %%
       cou_setReturnValue( cnx,
           ap_pstrdup(p,"text/html"),
	   CO_STRING
       );
       %%
       ;
     };
   };

   method getUserStartPage
   {
     id_permission __PERMISSION_GET;

     declare language_c
     {
       C
       %%
       int id_start_page = 0; // default
       FILE *fh;
       char *str_evaluation_mode;
       %%
       ;
     };

     body language_c
     {
       C
       %%
       __SEND_MESG_DEBUG("alleeerrrtttt: cnx->par_area=%s",cnx->par_area)
       
       __SQL_GET_INTEGER(id_start_page,"select r1.id_item from co_sec_role r1, co_sec_role r2
                       where r2.id=r1.id_parent
                       and r1.id_catalog_type=(select ct.id from co_sec_catalog_type ct where class_name='start_page')
		       and r2.id_catalog_type=(select ct.id from co_sec_catalog_type ct where class_name='user')
		       and r2.id_item=%d
		       ",cnx->id_user)
       if (!ok)
       {
         __SQL_GET_INTEGER(id_start_page,"select r1.id_item from co_sec_role r1, co_sec_role r2
                           where r2.id=r1.id_parent
                           and r1.id_catalog_type=(select ct.id from co_sec_catalog_type ct where class_name='start_page')
		           and r2.id_catalog_type=(select ct.id from co_sec_catalog_type ct where class_name='role')
		           and r2.id_item=%d
		           ",cnx->id_role)
       }

       if (id_start_page)
       {
         @co_call('"sec"','"start_page"',"getProp",par_id=>id_start_page,par_area=>'"sec"',par_class=>'"start_page"',prop_name=>'"evaluation_mode"');
         __GET_RETURNED_STRING(str_evaluation_mode)
         __SEND_MESG_DEBUG("start_page being evaluated as %s",str_evaluation_mode);
	 if (strcmp(str_evaluation_mode,"ASP"))
	 {
	   @co_call('"sec"','"start_page"',"getFile",par_class=>'"start_page"',par_area=>'"sec"',par_id=>id_start_page);
         }
	 else
	 {
	   @co_call('"sec"','"start_page"',"evalTextDocumentAsASP",par_class=>'"start_page"',par_area=>'"sec"',par_id=>id_start_page);
         }
       }
       else
       {
         char *index_file = ap_psprintf(p,"%s/index.html",cou_getCORootPath(cnx));
	 __PUT_HTML_FROM_FILE(index_file)
       }
       %%
       ;
     };
   };
};