%token WORD_NAME WORD_VAL
%{
package co;
use Ast;
use Carp;

%}

%%
program: /* nothing */
	| classes =
	    {
		#print "yacc: koniec przetwarzania\n";
		$root->add_prop_list("item_list", $1);
		$$ = $1;
	    }	
	;

classes: class = 
	    {
	    	#print "yacc: class : ", $1->{"class_name"}," \n";
		$$=$1;
	    }

	| class  classes =
	    {
		#print "yacc: class classes : ", $1->{"class_name"}," \n";
		$$ = $1;
	    }
	;

class:	
	| WORD_NAME WORD_NAME ';' =
	    {
	    	#print "yacc: WORD WORD: ", $1," ", $2," \n";
		#print "yacc: nastepny element : ", $0->{"ast_node_name"}," \n";

		local($a) = Ast->new($2);  #attribute name
                $a->add_prop ("name_".$1, $2);  #attribute type
                $a->add_prop ("name", $2);  #attribute type
		
		if(!($0->{"ast_node_name"})) 
		{
		    #print "yacc: zakladam nowe temp\n";
		    local($temp) = Ast->new("temp_".$2);
		    $temp->add_prop_list($1, $a);
		    $$=$temp;
		}
		else
		{
            	    $0->add_prop_list($1, $a);
		    $$=$0;
		}    
		
	    }    


    	| WORD_NAME WORD_NAME '{' classes  '}' ';' =
	    {
		#print "yacc: WORD WORD {}: ", $1," o nazwie: ", $2, " srodek: ",$4->{"ast_node_name"}," \n";
		#print "yacc: nastepny element : ", $0->{"ast_node_name"}," \n";

		#$a = Ast->new($2);  #attribute name
		local($a) = $4;
                $a->add_prop ("name_".$1, $2);  #attribute type
                $a->add_prop ("name", $2);  #attribute type
		
		if(!($0->{"ast_node_name"})) 
		{
		    #print "yacc: zakladam nowe temp\n";
		    local($temp) = Ast->new("temp_".$2);
		    $temp->add_prop_list($1, $a);
		    $$ = $temp;
		}
		else
		{
            	    $0->add_prop_list($1, $a);
		    $$=$0;
		}    
	    }
	;
	
		
	
%%

sub yylex
{
  while(1)
  {

    $line =~ s/^\s+//;
    #print "lex: wejscie :|", $line, "|\n";
    if ($line=~ s/^([\w_\**]+)//) {
	$yylval = $1;
	#print "lex: mamy word_name: ", $yylval, "\n";
    	return $WORD_NAME;
    }
    elsif($line=~ s/^(?=")(.*?[^\\])"//) {
        $yylval = substr($1,1);
	#print "lex: mamy cos w przed cudzyslowiu: ", $yylval, "\n";
	$yylval =~ s/\\\"/\"/g;
	#print "lex: mamy cos w cudzyslowiu: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif($line=~ s/^(?=')(.*?[^\\])'//) {
        $yylval = substr($1,1);
	#print "lex: mamy cos w pojedynczym przed cudzyslowiu: ", $yylval, "\n";
	$yylval =~ s/\\\'/\'/g;
	#print "lex: mamy cos w pojedynczym cudzyslowiu: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif($line=~ s/^(\%\%).*//) {
        $yylval = "";
	SUBLOOP: while (defined($line = <P>)) {
          $line_number++;
	  last SUBLOOP if $line=~ s/^(\s+\%\%).*// ;
	  $yylval .= $line
	}  
	#print "lex: mamy cos w procentach: ", $yylval, "\n";
	return $WORD_NAME;
    }	
    elsif ($line=~ s/^([\{\};\.])//) {
	#print "lex: mamy przerywnik", $1, "\n";
	$yylval = ord(substr($1,0,1));
	#print "lex: ", $yylval, "\n";
	return $yylval;
    }
    else {
	get_line();
	last if $koniec;
    }
  }
}




sub yyerror
{
    die "linia: ", $line_number, @_ ;
}


sub parse{
    my ($package, $filename) = @_;
    open (P, $filename) || die "Could not open $filename : $@";

    $root = Ast->new("Root");
    #$temp = Ast->new("Temp");

    get_line();
    &yyparse;	

    return $root;
}

sub get_line {
    while (defined($line = <P>)) {
        $line_number++;
        chomp $line;
        $line =~ s#^\s*//.*$##;          # remove comments
        return if $line !~ /^\s*$/;  # return if not white-space
    }
    $koniec = 1;

}


1;

#line 395 "y.tab.pl"
