// this is object representing one record
// that is shown on this page

// type = short or full
function myShowModalDialog(url)
{
    if (is_ie5up) {
        return window.showModalDialog(url);
    } else if (is_nav5up) {
        window.open(url, "ModalDialog", "chrome=no,dialog=yes,modal=yes");
        return window.retval;
    }
}

function objectRecord(number, par_class, par_id, root_div, type, arrFilter)
{
   //properties
   this.number = number;
   this.par_class = par_class;
   this.par_id = par_id;
   this.type = type;
   this.schema = new Object();
   this.arrFilter = arrFilter;

   //methods
   this.getNamespace = objectRecord_getNamespace;
   this.createField = createField;
   this.buildRowForm =  buildRowForm;
   this.buildRowFindForm =     buildRowFindForm;
   this.buildRowFindFormElem = buildRowFindFormElem;
   this.showFormFromSchema = showFormFromSchema;
   this.showFormFromReport = showFormFromReport;
   this.root_div = root_div;
   this.getParamsForMenu = getParamsForMenu;
}

function objectRecord_getNamespace()
{
  return this.number;
};

function getParamsForMenu()
{
	var ret  = urlEncode("active_area",  par_area);
	ret += urlEncode("active_class", this.par_class);
	ret += urlEncode("active_item", this.par_id);

	ret += urlEncode("context1", context1);
	ret += urlEncode("context2", context2);
	ret += urlEncode("context3", context3);

	ret += "selected_items=";
	var delim = "";
	for(var i=0; i<arrSelected.length; i++)
	{
		if(arrSelected[i]>0) 
		{
			ret += delim + arrSelected[i];
			delim = "|";
		}
	}
	ret+="&";
 //     ret += urlEncode("version",     this.record_data["version"][0]);
//	alert(ret);
  return ret;
};

var arrayObjectRecord= new Array();
var oVersions = new Object();
var id_window=0;
var no_navig_column = 1;
var active_col = -1;
var top_rows = 3;
var left_cols = 2;
var arrSelected = new Array();

var select_offset = 0;
var select_limit = 25;
var select_record_count = 0;

var execute_search = 0;

function objFilter(class_name, prop_name, oper, filter_value, order, active_value, params, position)
{
	this.class_name = class_name;
	this.prop_name = prop_name;
	this.oper = oper;
	this.filter_value = filter_value;
	this.order = order;
	this.active = active_value*1;
	this.position = Number(position);
	this.params = new Object()
	createParams(this.params, params)

};


// in this array we keep values for active record
var active_record = new Array();

// constructor for schema object
// takes as parameter raw schema (table) from database
function Schema(schema, par_class)
{
  this.vaColumnNames = schema.d.prop_name;
  this.vaColumnTables = schema.d.class_name;
  this.vaDisplayColumnNames = new Array();
  this.vaColumnParameters = schema.d.prop_params;
  this.vaRepresentant = schema.d.prop_representant;

  this.deleteProp = Schema_deleteProp;
  this.addProp    = Schema_addProp;

  // we need this property ALWAYS!
  this.name_prop = this.vaColumnNames[0];

  for(var i=0; i<schema.d.id.length; i++)
  {
    this.vaDisplayColumnNames[i] = this.vaColumnNames[i];
    this.vaColumnParameters[i] = String(this.vaColumnParameters[i]).split(";");
    for(var j=0; j<this.vaColumnParameters[i].length; j++)
    {
      var par = this.vaColumnParameters[i][j].split("=");
      this.vaColumnParameters[i][par[0]] = par[1];
    };

    // foreign fields are always READONLY
    if( this.vaColumnTables[i].toString().toLowerCase()!=par_class.toString().toLowerCase())
    {
       this.vaColumnParameters[i]["READONLY"] = 1;
       this.vaDisplayColumnNames[i] = this.vaColumnTables[i]+"."+this.vaDisplayColumnNames[i];
    };

    // for fields that are foreign keys we create links
    if(schema.d.col_foreign!="")
    {
       //this.vaColumnTables[i]+"."+this.vaDisplayColumnNames[i];
    };

    if(this.vaRepresentant[i]==100) 
    {
      this.name_prop = this.vaColumnNames[i];
    };
  };
};

function Schema_deleteProp(index)
{
  this.vaColumnNames.deleteElem(index);
  this.vaColumnTables.deleteElem(index);
  this.vaDisplayColumnNames.deleteElem(index);
  this.vaColumnParameters.deleteElem(index);
  this.vaRepresentant.deleteElem(index);
}
 
function Schema_addProp(index, class_name, prop_name)
{
  this.vaColumnNames.insert(prop_name, index);
  this.vaColumnTables.insert(class_name, index);
  this.vaDisplayColumnNames.insert(prop_name,index);
  this.vaColumnParameters.insert("",index);
  this.vaRepresentant.insert(0,index);
}
 
function createParams(o, init_string)
{
  o["HIDDEN"]=null;

  with(o)
  {
    eval(init_string);
  }
}

// creates input element in form for given field
function createField(index, value)
{
	var ret = document.createElement("INPUT");
	ret.className = "formItem";
	ret.setAttribute("value", value);
	ret.size = 15;

	// ret.id="P_" + this.getNamespace()+ "_" + this.schema.vaColumnNames[index];
	ret.id="P_" + index;
	var f_name = this.par_class + "_" + this.par_id + "_" + this.arrFilter[index].prop_name;
	ret.name= f_name;
	ret.priv_name =  this.arrFilter[index].prop_name;
	ret.priv_number = this.number;
	ret.priv_index = index;
	ret.onchange=function() {arrayObjectRecord[0].arrFilter[this.priv_index].filter_value = this.value;};
	ret.priv_oldclassName = ret.className;
	return ret;
}

function buildRowForm()
{
	var tr = this.root_div;;
	var td_val;
	var nr=0;
	for(var i=0; i<this.arrFilter.length; i++)
	{
	    
			
		if(!this.arrFilter[i].params.HIDDEN)
		{
			td_val = tr.insertCell(nr); nr++;
			var divField;
			if ((this.d[this.arrFilter[i].prop_name]!="")||!is_nav5up) {
				divField = document.createTextNode(this.d[this.arrFilter[i].prop_name].replace("\r", ""));
			} else {
				divField = document.createTextNode(".");
			}
			td_val.appendChild(divField);
						
		}
   }
   return 1;
};

function imageOKNO_handler()
{
	if(this.priv_active)
	{
		this.src = g_path + "other/no.gif";
		this.priv_active = 0;
		arrayObjectRecord[0].arrFilter[this.priv_index].active=0;
	}else
	{
		this.src = g_path + "other/yes.gif";
		this.priv_active = 1;
		arrayObjectRecord[0].arrFilter[this.priv_index].active=1;
	}
}    

function getOrderIconPath(order)
{
	if (order>0) return g_path + "other/asc.png";
	if (order<0) return g_path + "other/desc.png";
	return g_path + "other/noorder.png";
}

function imageORDER_handler()
{
	if(this.priv_order==0)
	{
		this.priv_order = 1;
		arrayObjectRecord[0].arrFilter[this.priv_index].order=1;
	} else if(this.priv_order>0) {
		this.priv_order = -1;
		arrayObjectRecord[0].arrFilter[this.priv_index].order=-1;
	} else { // <0
		this.priv_order = 0;
		arrayObjectRecord[0].arrFilter[this.priv_index].order=0;
	}
	this.src = getOrderIconPath(this.priv_order);
}    

function name_onclick_handler()
{
	//alert(active_col);
	if(active_col>=0)
	{
		old_td = document.getElementById("COLNAME_"+active_col);
		old_td.className = "colUnchecked";
	};  
	active_col = this.priv_index;
	this.className = "colChecked";
};    


function buildRowFindFormElem(i, td_name, td_value, td_oper, td_order)
{
	if(buildRowFindFormElem.arguments.length ==1)
	{
		var col_num = this.arrFilter[i].col_num;
		var td_name = document.getElementById("FIND_NAMES").cells(col_num  +left_cols);
		var td_value = document.getElementById("FIND_VALUES").cells(col_num+left_cols);
		var td_oper = document.getElementById("FIND_OPERS").cells(col_num  +left_cols);
		var td_order = document.getElementById("FIND_ORDERS").cells(col_num +left_cols);
	}
      
	// VALUES
//	var col_num = i+left_cols;
//	var td_val = tr_values.cells[col_num];

//    alert(this.arrFilter[i].prop_name);
	var divField = this.createField(i,this.arrFilter[i].filter_value);
	td_value.appendChild(divField);

	//NAMES
//	var td_val = tr_names.cells[col_num];
	var img = document.createElement("IMG");
	img.id = "IMG_"+i;
	//alert("active="+this.arrFilter[i].active);
	if (this.arrFilter[i].active) img.src = g_path + "other/yes.gif";
	else img.src = g_path + "other/no.gif";
	img.width =10;
	img.height=10;
	img.priv_active = this.arrFilter[i].active;
	img.priv_index = i;
	img.className = "imageOKNO";
	img.onclick = imageOKNO_handler;
	td_name.appendChild(img);
	td_name.priv_index = i;
	td_name.id = "COLNAME_"+i;
	td_name.className = "tdFindName";
	td_name.onclick = name_onclick_handler; 
	var text = document.createTextNode(this.arrFilter[i].prop_name);
	td_name.appendChild(text);

	//OPERS
//	var td_val = tr_opers.cells[col_num];
	var inp = document.createElement("SELECT");
	inp.className = "formItem";
	inp.id = "SEL_"+i;
	inp.priv_index = i;
	inp.onchange=function() { arrayObjectRecord[0].arrFilter[this.priv_index].oper = this.value;};
	var arrOperators = new Array ( "LIKE", "<", ">", "=", "<=", ">=" );
	for(var j=0; j<arrOperators.length; j++)
	{
		var opt = document.createElement("OPTION");
		var text = document.createTextNode(arrOperators[j]);
		opt.appendChild(text);
		opt.value = arrOperators[j];
		inp.appendChild(opt);
		if(opt.value == this.arrFilter[i].oper) { opt.selected=true;}
	}
	td_oper.appendChild(inp);

	//ORDERS
	var img = document.createElement("IMG");
	var order = this.arrFilter[i].order;
	img.id = "IMGORD_"+i;
	//alert("active="+this.arrFilter[i].order);
	img.src = getOrderIconPath(order);
	//img.width =10;
//	img.style.width ="100%";
//	img.style.height="1em";
	img.priv_order = this.arrFilter[i].order;
	img.priv_index = i;
	img.className = "imageORDER";
	img.onclick = imageORDER_handler;
	td_order.appendChild(img);
	td_order.priv_index = i;
	td_order.id = "COLORDER_"+i;
	td_order.className = "tdOrder";
	//td_order.onclick = order_onclick_handler; 
} 

function filter_sort(x, y)
{
	if (x.position>y.position) return 1;
	if (x.position<y.position) return -1;
	return 0;
}

function buildRowFindForm()
{
	this.arrFilter.sort(filter_sort);

	var tr_names = document.getElementById("FIND_NAMES");
	var tr_values = document.getElementById("FIND_VALUES");
	var tr_opers = document.getElementById("FIND_OPERS");
	var tr_orders = document.getElementById("FIND_ORDERS");

	// inserting blank cells (2)
	for(var i=0; i< left_cols; i++)
	{
		tr_values.insertCell(i);
		tr_names.insertCell(i);
		tr_opers.insertCell(i);
		tr_orders.insertCell(i);
	}

	var j=left_cols;
	for(var i=0; i<this.arrFilter.length; i++)
	{
		if(!this.arrFilter[i].params.HIDDEN)
		{
			var td_name = tr_names.insertCell(j);
			var td_value = tr_values.insertCell(j);
			var td_oper = tr_opers.insertCell(j);
			var td_order = tr_orders.insertCell(j);
			//this.arrFilter[i] = new objFilter(this.schema.vaColumnTables[i], this.schema.vaColumnNames[i], "LIKE", "");
			this.arrFilter[i].col_num = j; 
			this.buildRowFindFormElem(i, td_name, td_value, td_oper, td_order);
			j++;
		}

	}
	return 1;
}

function showFormFromSchema(raw_schema)
{
//  alert("z showForm");
	this.schema =  new Schema(raw_schema,this.par_class);
	this.arrFilter = new Array();

	for(var i=0; i<raw_schema.d.id.length; i++)
	{
	    this.arrFilter[i] = new objFilter(raw_schema.d.class_name[i], raw_schema.d.prop_name[i], "LIKE", "",0,0,0);
// nie pokazujemy pl ktore nie sa uzywane (deleted, inherits_acl,version)	    
	    var my_field_name = raw_schema.d.prop_name[i];
	    if ((my_field_name=="version")||(my_field_name=="deleted")||(my_field_name=="inherits_acl")) this.arrFilter[i].params.HIDDEN=1;
	    
	}
	var ret=this.buildRowFindForm();
}

var search_interval;

function exe_search()
{
	if (is_nav5up) {
		select();
	} else if (is_ie5up) {
		document.getElementById("FIND_GIF").click();
	}
	execute_search = 0;
	window.clearInterval(search_interval);
}

function showFormFromReport(report_data)
{
//  alert("z showForm");
//	this.schema =  new Schema(raw_schema,this.par_class);
	this.schema=null;
	this.arrFilter = new Array();

	var prop_name;
	var f_value;

	for(var i=0; i<report_data.d.id.length; i++)
	{
		prop_name = report_data.d.prop_name[i];
		if(filter_variables[prop_name] != null)
		{
			f_value =  filter_variables[prop_name];
		}
		else
		{
			f_value =  report_data.d.filter_value[i]; 
		}

	    this.arrFilter[i] = new objFilter(report_data.d.class_name[i], 
		                                  prop_name, 
		                                  report_data.d.filter_operator[i], 
		                                  f_value, 
		                                  //report_data.d.order_by[i],
		                                  "",
						  report_data.d.active[i],
		                                  report_data.d.params[i],
		                                  ""
						  //report_data.d.position[i]
		                                  );
	}
	var ret=this.buildRowFindForm();
	if (execute_search)
	{
		search_interval = window.setInterval("exe_search()", 100);
    }  
}


function image_data_onclick_handler()
{
	if(this.priv_active)
	{
		this.src = g_path + "other/no.gif";
		this.priv_active = 0;
		arrSelected[this.priv_index]=0;
	}else
	{
		this.src = g_path + "other/yes.gif";
		this.priv_active = 1;
		arrSelected[this.priv_index]=this.priv_id_object;
	}
}    
 
function showReturned(vaDane)
{
try {
	//setting general info
	var td_from = document.getElementById("RECORD_FIRST");
//	var text = document.createTextNode(select_offset);
//	clear(td_from);
//	td_from.appendChild(text);
	td_from.firstChild.nodeValue = 1+select_offset;

	var td_last = document.getElementById("RECORD_LAST");
//	var text = document.createTextNode(select_limit+select_offset);
//	clear(td_last);
//	td_last.appendChild(text);
	td_last.firstChild.nodeValue = select_offset+select_limit;
   /////////////////////////////////////////////////

	var schema = arrayObjectRecord[0].schema;
	var arrFilter = arrayObjectRecord[0].arrFilter;
	var tab = document.getElementById("MAIN_TABLE");

	// deleting old rows with data
   while(tab.rows.length > 4)
	{
		tab.deleteRow(tab.rows.length-1);
	};

	if(typeof(vaDane)=="object")
	{
		// we create array to keep inormation witch rows are selected
		arrSelected = new Array(vaDane.d.id.length);

		// next rows have values
		for(var i=0; i<vaDane.d.id.length; i++)
		{
			var l = arrayObjectRecord.length;
//old:			var tr = tab.insertRow();
			var tr = tab.insertRow(tab.rows.length);
			//here we are setting bacground collor for new row (we are using styles defined in generic_head.html)			
			tr.className = "trData" + (Math.round(i/2)*2-i);
			//alert("test:" + vaDane.d.id.length);
			if ((vaDane.d.deleted[i])!=0) {
			  tr.className = "trDataDeleted"
			
			};			
			// we assume that id column is always taken
			arrayObjectRecord[l] = new objectRecord(l, par_class, vaDane.d.id[i],tr,"short");
			var cur_obj = arrayObjectRecord[l];
			cur_obj.schema = schema;
			cur_obj.arrFilter = arrFilter;
			tr.id = "DATA_" +  arrayObjectRecord[l].getNamespace();
			tr.priv_length = vaDane.length;
			cur_obj.d = new Object();
			for(f in vaDane.d)
			{
				cur_obj.d[f] = vaDane.d[f][i];
				if(f=="version")
				{
					oVersions[cur_obj.par_class+"_"+cur_obj.par_id] = vaDane.d[f][i];
				};    
			};
			arrayObjectRecord[l].buildRowForm();
			var td = tr.insertCell(0);
			var img = document.createElement("IMG");
			
			img.src = g_path + "other/no.gif";
			img.width =10;
			img.height=10;
			img.priv_active = 0;
			img.priv_index = i;
			img.priv_id_object = cur_obj.par_id;
			img.className = "imageOKNO";
			img.onclick = image_data_onclick_handler; 
			td.appendChild(img); 
			var td = tr.insertCell(0);
			var text = document.createTextNode("E");
			td.appendChild(text);
			td.priv_number = arrayObjectRecord[l].number;
			// effect depends on if className was set _after_ cell was added to parent or _before_
			//td.className = "tdEdit";
			td.onclick = function () { openRelated(this.priv_number, default_open_class_name, default_open_id_prop_name);};
		} // for all props
	} // if has data

	var img = document.getElementById("FIND_GIF"); 
	img.src = g_path + "other/find.gif";

	return 1;
} catch (e) {var desc="Error: "; for (var m in e ) {desc+=e[m]+" ";}; alert(desc); }
} 

function showRecordCount(vaData)
{
  select_record_count = vaData.d.id[0];
  var td_record_count = document.getElementById("RECORD_COUNT");
//  clear(td_record_count);
//  var text = document.createTextNode(select_record_count);
//  td_record_count.appendChild(text); 
	td_record_count.firstChild.nodeValue = select_record_count;
};

function setRecordData(vaData)
{
  this.record_data = vaData.d;
  oVersions[this.par_class+"_"+vaData.d.id[0]] = vaData.d["version"][0];
  this.showRecordData();
};

function prop_add()
{
	if(active_col<0) 
	{
		alert("Nie zaznaczye kolumny!");
		return -1;
	}

	var url= "/co/asp/" + par_area + "/generic?selectFieldToAdd&active_class="+class_name+"&debug_level=1";
	//var prop_name = window.showModalDialog(url);
	var prop_name = myShowModalDialog(url);

	var class_name = par_class;

	// adding to arrFilter
	var active_col_num = 0; // number of column in html table
	for(var i=0; i<active_col; i++)
	{
		if(!arrayObjectRecord[0].arrFilter[i].params.HIDDEN)
		{
			active_col_num ++;
		}
	}			
//	alert(active_col + "; " + active_col_num);

	var NColumns = arrayObjectRecord[0].arrFilter.length-1;
	var tab = document.getElementById("MAIN_TABLE");
	// setting new ids
	for(var i=NColumns; i>=active_col; i--)
	{
//		alert(i);
		if(!arrayObjectRecord[0].arrFilter[i].params.HIDDEN)
		{

			var td = document.getElementById("COLNAME_"+(i));
			td.id = "COLNAME_"+(i+1);
			td.priv_index++;

			var td = document.getElementById("P_"+(i));
			td.id = "P_"+(i+1);
			td.priv_index++;

			var td = document.getElementById("IMG_"+(i));
			td.id = "IMG_"+(i+1);
			td.priv_index++;

			var td = document.getElementById("SEL_"+(i));
			td.id = "SEL_"+(i+1);
			td.priv_index++;
		}
	}

	var newFilter = new objFilter(class_name, prop_name, "LIKE", "", 0);
	arrayObjectRecord[0].arrFilter.insert(newFilter, active_col);

	//-----------------------------------------------------------------------
	// DANGER THIS SHOULD BE TAKEN FROM DATABASE!
	if(arrayObjectRecord[0].schema!=null) arrayObjectRecord[0].schema.addProp(active_col, class_name, prop_name);
	//------------------------------------------------------------------------

  // inserting column to table
	var col_to_add = active_col_num + left_cols;
	htmlTable_insertColumn(tab, col_to_add);

	arrayObjectRecord[0].arrFilter[active_col].col_num = active_col_num;
	arrayObjectRecord[0].buildRowFindFormElem(active_col);
	active_col++;
}

function prop_del()
{

	if(active_col<0) 
	{
		alert("Nie zaznaczye kolumny!");
		return -1;
	}

	var active_col_num = 0; // number of column in html table
	for(var i=0; i<active_col; i++)
	{
		if(!arrayObjectRecord[0].arrFilter[i].params.HIDDEN)
		{
			active_col_num ++;
		}
	}			
	
	// deleting from arrFilter

	var tab = document.getElementById("MAIN_TABLE");
	var col_to_delete = active_col_num + left_cols;
	htmlTable_deleteColumn(tab, col_to_delete);

	// setting new ids
	var NColumns = arrayObjectRecord[0].arrFilter.length;
	for(var i=active_col+1; i<NColumns; i++)
	{
//		alert(i);
		if(!arrayObjectRecord[0].arrFilter[i].params.HIDDEN)
		{
			var td = document.getElementById("COLNAME_"+i);
			td.id = "COLNAME_"+(i-1);
			td.priv_index--;

			var td = document.getElementById("P_"+i);
			td.id = "P_"+(i-1);
			td.priv_index--;

			var td = document.getElementById("IMG_"+i);
			td.id = "IMG_"+(i-1);
			td.priv_index--;

			var td = document.getElementById("SEL_"+i);
			td.id = "SEL_"+(i-1);
			td.priv_index--;
		}
	}
	arrayObjectRecord[0].arrFilter.deleteElem(active_col);
	
	if(arrayObjectRecord[0].schema!=null) arrayObjectRecord[0].schema.deleteProp(active_col);
	active_col = -1;
}
    

// INTERFACE FUNCTIONS

function show_message(str)
{
  alert(str);
};

function co_insert(o)
{
};         

function co_create()
{
};

function co_refresh(vaFields)
{
};//func

//====================================================================
// communication functions

function openRelated(table_number, default_open_class_name, default_open_id_prop_name)
{
    var objForm = arrayObjectRecord[table_number];
	var url = "/co/html/" + par_area + "/";
	if(openRelated.arguments.length ==1)
	{
		url += objForm.par_class+"?showForm&par_id="+objForm.par_id;
	}
	else
	{
		url += default_open_class_name +"?showForm&par_id="+ objForm.d[default_open_id_prop_name];
	}
	url += "&deep_level=2&debug_level=0";
/*
    window.open(url, id_session + "WW" + id_window, "toolbar=0,menubar=0,resizable=1,scrollbars=1");
    id_window ++;
*/
    window.open(url, "_blank", "toolbar=0,menubar=0,resizable=1,scrollbars=1");
};   



function initForm(number)
{
//    alert("jestem w initFrom");
	var objForm = arrayObjectRecord[number];
	if(id_report==0)
	{	
		var param = objForm.par_class+"?getSchema&";
		param += urlEncode("par_area", par_area);
		param += urlEncode("par_class", objForm.par_class);
		param += urlEncode("par_id", objForm.par_id);
		callback = "arrayObjectRecord["+number+"].showFormFromSchema(";
		param += urlEncode("callback",  callback);
		//alert(param);
	}
	else
	{
		var param = "report?getRelatedData&";
		param += urlEncode("par_area", par_area);
		param += urlEncode("par_class", "report");
		param += urlEncode("par_id", id_report);
		param += urlEncode("related_class", "report_element");
		param += urlEncode("related_prop", "id_report");
		callback = "arrayObjectRecord["+number+"].showFormFromReport(";
		param += urlEncode("callback",  callback);
	}
	PutRequest(param);
};

function init()
{
//  alert("jestem w init");
	var root_div = document.getElementById("FIND_VALUES");
	arrayObjectRecord[0] = new objectRecord(0,par_class,par_id,root_div,"short");
	document.title = "LeftHand " + par_class + " (wyszukiwanie)";
	var menu_tag = document.getElementById("MENU");
	arrMenus[0] = new menu(0, par_class, -1, menu_tag, "default", "multi");
	arrMenus[0].getParams = function() { return arrayObjectRecord[0].getParamsForMenu();};;

	if(context_name!="")
	{
//		alert(context_name);
		var menu_tag = document.getElementById("MENU_CONTEXT");
		arrMenus[1] = new menu(1, par_class, -1, menu_tag, context_name, "multi");
		arrMenus[1].getParams = function() { return arrayObjectRecord[0].getParamsForMenu();};;
	}
/*
	if(id_report!=0)
	{
//		alert(context_name);
		var menu_tag = document.getElementById("MENU_REPORT");
		arrMenus[2] = new menu(2, par_class, -1, menu_tag, context_name, "multi");
		arrMenus[2].getParams = function() { return arrayObjectRecord[0].getParamsForMenu();};;
	}
*/	
	initForm(0);

	//if(id_report!=0) execute_search = 1;
};

function select_next()
{
  select_offset += select_limit;
  if(select_offset< select_record_count)
  {
     select();
  }
  else
  {
	select_offset = select_record_count-1;
    alert("Nie ma wicej rekordw!");
  }
}

function select_prev()
{
  select_offset -= select_limit;
  if(select_offset>=0)
  {
     select();
  }
  else
  {
	select_offset=0;
    alert("Nie ma wicej rekordw!");
  }
}


function select()
{
//	alert(objToString(arrFilter));

	var img = document.getElementById("FIND_GIF");
	img.src = g_path + "other/find_on.gif";

	arrFilter = arrayObjectRecord[0].arrFilter;
	var param = "*?"+par_class+"/selectX&";
	//var prop_name = "class_name";
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", par_class);
	param += urlEncode("par_id", par_id);

	var get_class_names = new Array(arrFilter[0].class_name);
	var get_prop_names = new Array("id");
	
	var filter_class_names = new Array();
	var filter_prop_names = new Array();
	var filter_values = new Array();	
	var filter_operators = new Array();	
	var filter_r_class_names = new Array();
	var filter_r_prop_names = new Array();
	var filter_compare = new Array();	
	
	var arr_prop_name = new Array();
	 
	var order_by_class_names = new Array();
	var order_by_prop_names = new Array();
	var order_by_desc = new Array();	

	var j=0;
	var s=0; //s for 'sort'
	
	for(var i=0; i<arrFilter.length; i++)
	{
  	  get_class_names[i+1] = arrFilter[i].class_name
	  get_prop_names[i+1] = arrFilter[i].prop_name;
	  if(arrFilter[i].active)
	  {	
	  
	    arr_prop_name=(arrFilter[i].prop_name).split(">");
		//alert(arrFilter[i].prop_name);
		
		if (arr_prop_name.length==1) {

		  //alert(arrFilter[i].class_name);
	  	  filter_class_names[j] = arrFilter[i].class_name;
	  	  filter_prop_names[j] = arrFilter[i].prop_name;
	  	  filter_values[j] = arrFilter[i].filter_value
	  	  filter_operators[j] = arrFilter[i].oper;
	  	  filter_r_class_names[j] = "";
	  	  filter_r_prop_names[j] = "";
	  	  filter_compare[j] = "";		
		  
		} else {		
		  
	  	  filter_class_names[j] = arr_prop_name[2];
	  	  filter_prop_names[j] = arr_prop_name[3];
	  	  filter_values[j] = arrFilter[i].filter_value;
	  	  filter_operators[j] = arrFilter[i].oper;
	  	  filter_r_class_names[j] = "";
	  	  filter_r_prop_names[j] ="";
	  	  filter_compare[j] = "";		

		  j++;
		  
	  	  filter_class_names[j] = arrFilter[i].class_name;
	  	  filter_prop_names[j] = arr_prop_name[0];
	  	  filter_values[j] = "";
	  	  filter_operators[j] = "=";
	  	  filter_r_class_names[j] = arr_prop_name[2];
	  	  filter_r_prop_names[j] =arr_prop_name[1];
	  	  filter_compare[j] = "1";		
		    
		  //alert('class: ' + arrFilter[i].class_name);
		  //alert('prop: ' +arr_prop_name[0]);
		  //alert('rclass: ' +arr_prop_name[2]);		  		  
		  //alert('rprop: ' +arr_prop_name[1]);		  
		
		}  

	    j++;
	  };
	  if(arrFilter[i].order>0)
	  {
	    order_by_class_names[s] = arrFilter[i].class_name;
	    order_by_prop_names[s] = arrFilter[i].prop_name;
	    order_by_desc[s] = "";
	    s++;
	  };
	  if(arrFilter[i].order<0)
	  {
	    order_by_class_names[s] = arrFilter[i].class_name;
	    order_by_prop_names[s] = arrFilter[i].prop_name;
	    order_by_desc[s] = "1";
	    s++;
	  };
	};    
	// s>0 <=> sorting required

	if(j==0)
	{
	  alert("nic nie zaznaczye!");
	  return 0;
	};

	param += urlEncodeArray("_get_class_names", get_class_names);
	param += urlEncodeArray("_get_prop_names", get_prop_names);	
//	param += urlEncode("top", 200);
	param += urlEncodeArray("_filter_class_names", filter_class_names);
	param += urlEncodeArray("_filter_prop_names", filter_prop_names);
	param += urlEncodeArray("_filter_values", filter_values);
	param += urlEncodeArray("_filter_operators", filter_operators);
	param += urlEncodeArray("_filter_r_class_names", filter_r_class_names);
	param += urlEncodeArray("_filter_r_prop_names", filter_r_prop_names);
	param += urlEncodeArray("_filter_compare", filter_compare);


	if (s>0) {
		param += urlEncodeArray("_order_by_class_names", order_by_class_names);
		param += urlEncodeArray("_order_by_prop_names", order_by_prop_names);
		param += urlEncodeArray("_order_by_desc", order_by_desc);
	}

	param += urlEncode("limit",  select_limit);
	param += urlEncode("offset", select_offset);

	var callback = "showReturned(";
	param += urlEncode("callback",callback);

	//FOR GETTING RECORD COUNT
	param += "&" + par_class + "/selectX&"
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", par_class);
	param += urlEncode("par_id", par_id);

	var get_class_names = new Array();
	var get_prop_names = new Array();
	var get_prop_aggregates = new Array();
  	get_class_names[0] = arrFilter[0].class_name;
	get_prop_names[0] = "id";
	get_prop_aggregates[0] = "COUNT";
	
	param += urlEncodeArray("_get_class_names", get_class_names);
	param += urlEncodeArray("_get_prop_names", get_prop_names);	
	param += urlEncodeArray("_get_prop_aggregates", get_prop_aggregates);	

//	param += urlEncode("top", 200);
	param += urlEncodeArray("_filter_class_names", filter_class_names);
	param += urlEncodeArray("_filter_prop_names", filter_prop_names);
	param += urlEncodeArray("_filter_values", filter_values);
	param += urlEncodeArray("_filter_operators", filter_operators);
	param += urlEncodeArray("_filter_r_class_names", filter_r_class_names);
	param += urlEncodeArray("_filter_r_prop_names", filter_r_prop_names);
	param += urlEncodeArray("_filter_compare", filter_compare);


//	param += urlEncode("limit",  select_limit);
//	param += urlEncode("offset", select_offset);

	var callback = "showRecordCount(";
	param += urlEncode("callback",callback);

	// PUTTING REQUEST 
//	alert(param);
	PutRequest(param);
};



function select_old()
{
//	alert(objToString(arrFilter));

	var img = document.getElementById("FIND_GIF");
	img.src = g_path + "other/find_on.gif";

	arrFilter = arrayObjectRecord[0].arrFilter;
	var param = "*?"+par_class+"/selectX&";
	//var prop_name = "class_name";
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", par_class);
	param += urlEncode("par_id", par_id);

	var get_class_names = new Array(arrFilter[0].class_name,arrFilter[0].class_name);
	var get_prop_names = new Array("id","deleted");
	var filter_class_names = new Array();
	var filter_prop_names = new Array();
	var filter_values = new Array();	
	var filter_operators = new Array();	
	var order_by_class_names = new Array();
	var order_by_prop_names = new Array();
	var order_by_desc = new Array();	

	var j=0;
	var s=0; //s for 'sort'
	for(var i=0; i<arrFilter.length; i++)
	{
  	  get_class_names[i+2] = arrFilter[i].class_name
	  get_prop_names[i+2] = arrFilter[i].prop_name;
	  if(arrFilter[i].active)
	  {
	    filter_class_names[j] = arrFilter[i].class_name;
	    filter_prop_names[j] = arrFilter[i].prop_name;
	    filter_values[j] = arrFilter[i].filter_value
	    filter_operators[j] = arrFilter[i].oper;
	    j++;
	  };
	  if(arrFilter[i].order>0)
	  {
	    order_by_class_names[s] = arrFilter[i].class_name;
	    order_by_prop_names[s] = arrFilter[i].prop_name;
	    order_by_desc[s] = "";
	    s++;
	  };
	  if(arrFilter[i].order<0)
	  {
	    order_by_class_names[s] = arrFilter[i].class_name;
	    order_by_prop_names[s] = arrFilter[i].prop_name;
	    order_by_desc[s] = "1";
	    s++;
	  };
	};    
	// s>0 <=> sorting required

	if(j==0)
	{
	  alert("nic nie zaznaczye!");
	  return 0;
	};

	param += urlEncodeArray("_get_class_names", get_class_names);
	param += urlEncodeArray("_get_prop_names", get_prop_names);	
//	param += urlEncode("top", 200);
	param += urlEncodeArray("_filter_class_names", filter_class_names);
	param += urlEncodeArray("_filter_prop_names", filter_prop_names);
	param += urlEncodeArray("_filter_values", filter_values);
	param += urlEncodeArray("_filter_operators", filter_operators);

	if (s>0) {
		param += urlEncodeArray("_order_by_class_names", order_by_class_names);
		param += urlEncodeArray("_order_by_prop_names", order_by_prop_names);
		param += urlEncodeArray("_order_by_desc", order_by_desc);
	}

	param += urlEncode("limit",  select_limit);
	param += urlEncode("offset", select_offset);

	var callback = "showReturned(";
	param += urlEncode("callback",callback);

	//FOR GETTING RECORD COUNT
	param += "&" + par_class + "/selectX&"
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", par_class);
	param += urlEncode("par_id", par_id);

	var get_class_names = new Array();
	var get_prop_names = new Array();
	var get_prop_aggregates = new Array();
  	get_class_names[0] = arrFilter[0].class_name;
	get_prop_names[0] = "id";
	get_prop_aggregates[0] = "COUNT";
	
	param += urlEncodeArray("_get_class_names", get_class_names);
	param += urlEncodeArray("_get_prop_names", get_prop_names);	
	param += urlEncodeArray("_get_prop_aggregates", get_prop_aggregates);	

//	param += urlEncode("top", 200);
	param += urlEncodeArray("_filter_class_names", filter_class_names);
	param += urlEncodeArray("_filter_prop_names", filter_prop_names);
	param += urlEncodeArray("_filter_values", filter_values);
	param += urlEncodeArray("_filter_operators", filter_operators);

	param += urlEncode("limit",  select_limit);
	param += urlEncode("offset", select_offset);

	var callback = "showRecordCount(";
	param += urlEncode("callback",callback);

	// PUTTING REQUEST 
//	alert(param);
	PutRequest(param);
};

function selectRecordCount()
{
//	alert(objToString(arrFilter));
	arrFilter = arrayObjectRecord[0].arrFilter;
	var param = par_class+"?selectX&";
	//var prop_name = "class_name";
	param += urlEncode("par_area", par_area);
	param += urlEncode("par_class", par_class);
	param += urlEncode("par_id", par_id);

	var get_class_names = new Array();
	var get_prop_names = new Array();
	var get_prop_aggregates = new Array();
	var filter_class_names = new Array();
	var filter_prop_names = new Array();
	var filter_values = new Array();	
	var filter_operators = new Array();	

  	get_class_names[0] = arrFilter[0].class_name;
	get_prop_names[0] = "id";
        get_prop_aggregates[0] = "COUNT";
	
	var j=0;
	for(var i=0; i<arrFilter.length; i++)
	{
	  if(arrFilter[i].active)
	  {
	    filter_class_names[j] = arrFilter[i].class_name;
	    filter_prop_names[j] = arrFilter[i].prop_name;
	    filter_values[j] = arrFilter[i].filter_value
	    filter_operators[j] = arrFilter[i].oper;
	    j++;
	  };
	};    

	if(j==0)
	{
	  alert("nic nie zaznaczyles!");
	  return 0;
	};

	param += urlEncodeArray("_get_class_names", get_class_names);
	param += urlEncodeArray("_get_prop_names", get_prop_names);	
	param += urlEncodeArray("_get_prop_aggregates", get_prop_aggregates);	

//	param += urlEncode("top", 200);
	param += urlEncodeArray("_filter_class_names", filter_class_names);
	param += urlEncodeArray("_filter_prop_names", filter_prop_names);
	param += urlEncodeArray("_filter_values", filter_values);
	param += urlEncodeArray("_filter_operators", filter_operators);

	param += urlEncode("limit",  select_limit);
	param += urlEncode("offset", select_offset);

	var callback = "showRecordCount(";
	param += urlEncode("callback",callback);
//	alert(param);
	PutRequest(param);
};


window.onload = init;

