#ifndef CODEFINESH
#define CODEFINESH

#define SQLBUFSIZE 10000
#define JSBUFSIZE 100000
#define FIELDBUFSIZE 20000
#define MAXSELECTPAR 1000
#define FILENAMELENGTH 128
#define MAXFIELDNUMBER 1000
#define MESGSIZE       10000

#define __PARAMS_MAGIC_WITH_PAR_AREA 1112
#define __PARAMS_MAGIC_NO_PAR_AREA   7772

#define __PARAMS_MAGIC_WITH_PAR_CLASS 1113
#define __PARAMS_MAGIC_NO_PAR_CLASS   7773

#define __PARAMS_MAGIC_WITH_PAR_ID 1114
#define __PARAMS_MAGIC_NO_PAR_ID   7774


#define cou_jsputs(cnx, str) \
        cos_AppendString(cnx, (cnx)->js_response, str)

#define cou_jsprintf(cnx, format, args... )\
        cos_AppendFormatted(cnx, (cnx)->js_response, format, ## args)

#define cou_msgputs(cnx, str) \
        cos_AppendString(cnx, (cnx)->messages, str)

#define cou_msgprintf(cnx, format, args... )\
        cos_AppendFormatted(cnx, (cnx)->messages, format, ## args)

#define __CREATE_MESG( format, args... )\
	{ int req_size; \
	if( (req_size=snprintf(MESGString, MESGSIZE, format, ## args ))>=MESGSIZE) {\
	    cou_logError(cnx, CO_LOG_ERR, "Required message buffer size: %d", req_size); \
            cou_error(cnx, "snprintf failed in __CREATE_MESG: buffer too small"); \
	}}

#define __SEND_MESG_DEBUG( format, args... )\
        __CREATE_MESG( format, ## args) \
        cou_sendMessageX(cnx, MESGString, CO_MSG_DEBUG);

#define __SEND_MESG_FORCE( format, args... )\
        __CREATE_MESG( format, ## args) \
        cou_sendMessageX(cnx, MESGString, CO_MSG_FORCE);

#define __METHOD__ "not defined"

#define __ASSERT(CONDITION, MESG, args... )   if(!(CONDITION)) { \
 __SEND_MESG_FORCE("ASSERT FAILED IN FILE: %s LINE: %d METHOD: %s ", __FILE__, __LINE__, __METHOD__) \
 __SEND_MESG_FORCE(MESG, ## args) \
 return -1; }


#define __ASSERT_NULL(CONDITION, MESG, args... )   if(!(CONDITION)) { \
 __SEND_MESG_FORCE("ASSERT_NULL FAILED IN FILE: %s LINE: %d METHOD: %s ", __FILE__, __LINE__, __METHOD__) \
 __SEND_MESG_FORCE(MESG, ## args) \
 return NULL; }

#define __RETURN_INTEGER( VAR_NAME ) \
           cou_setReturnValue(cnx, (void *) &(VAR_NAME), CO_INTEGER);

#define __RETURN_STRING( VAR_NAME ) \
           cou_setReturnValue(cnx, (void *)(VAR_NAME), CO_STRING);

#define __RETURN_RECORDSET( VAR_NAME ) \
           cou_setReturnValue(cnx, (void *)(VAR_NAME), CO_RECORDSET);

#define __GET_RETURNED_INTEGER( VAR_NAME ) \
	{ \
	 void *ptr; int err; \
         ptr = cou_getReturnValue(cnx, CO_INTEGER, &err); \
	 __ASSERT(ptr, "No CO_INTEGER value was returned" ) \
         VAR_NAME = *(int *) ptr; \
	}

#define __GET_RETURNED_STRING( VAR_NAME ) \
	{ \
	 void *ptr; int err; \
         ptr = cou_getReturnValue(cnx, CO_STRING, &err); \
	 __ASSERT(ptr, "No CO_STRING value was returned" ) \
         VAR_NAME = ptr; \
	}

#define __GET_RETURNED_RECORDSET( VAR_NAME ) \
	{ \
	 void *ptr; int err; \
         ptr = cou_getReturnValue(cnx, CO_RECORDSET, &err); \
	 __ASSERT(ptr, "No CO_RECORDSET value was returned" ) \
         VAR_NAME = ptr; \
	}

#define __CO_METHOD(method_name) \
                int method_name (co_context *cnx)\
                { \
                    request_rec *r = cnx->request; \
                    PGconn *conn = cnx->dbconn; \
                    PGresult *res; \
		    char SQLString[SQLBUFSIZE]; \
                    char JSOutBuf[JSBUFSIZE]; \
                    int ok; \
                    int err; \
		    int dirty_res = 0; \
                    char *delim = "=";\
                    __GET_SQL_NAME(par_area)\
                    __GET_SQL_NAME(par_class)


#define __INIT_VARIABLES \
	    memset(SQLString, 0, SQLBUFSIZE);\
	    memset(JSOutBuf, 0, JSBUFSIZE);


#define __GET_PARAM_POINTER(param_name, ret_type,co_get_type) \
          ret_type param_name = ({ \
             ret_type out=(ret_type)cou_getParam(cnx,#param_name,co_get_type, &err);\
              __GET_PARAM_ERROR_HANDLER(param_name); \
           out;});

#define __GET_PARAM_VALUE(param_name, ret_type,co_get_type) \
          ret_type param_name = ({ret_type out=*(ret_type *)cou_getParam(cnx,#param_name,co_get_type, &err);\
         __GET_PARAM_ERROR_HANDLER(param_name) \
         out;});

#define __GET_PARAM_ARRAY(param_name, ret_type) \
          ret_type param_name = ({ret_type out=(ret_type)cou_getParamArray(cnx,"_"#param_name,delim,MAXSELECTPAR, &err);\
         __GET_PARAM_ERROR_HANDLER(param_name) \
         out;});


#define __GET_PARAM_ERROR_HANDLER(param_name) \
          if(err != 0) cou_error(cnx, "BLAD PRZY POBIERANIU PARAMETRU: " #param_name);

#define __GET_STRING(param_name) __GET_PARAM_POINTER(param_name, char *, CO_STRING)

#define __GET_SQL_VALUE(param_name) __GET_PARAM_POINTER(param_name, char *, CO_STRING_SQL_VALUE)

#define __GET_SQL_NAME(param_name) __GET_PARAM_POINTER(param_name, char *, CO_STRING_SQL_NAME)

#define __GET_INTEGER(param_name) __GET_PARAM_VALUE(param_name, int, CO_INTEGER)

#define __GET_ARRAY_OF_STRINGS(param_name) __GET_PARAM_ARRAY(param_name, char **)


#define __SQL_GET_RESULT \
    cou_sendMessageX(cnx, ap_psprintf(p, "entering __SQL_GET_RESULT with SQL: %s",SQLString), CO_MSG_DEBUG); \
    corec = cor_CreateOnSQLString(cnx, SQLString); \
    ok = cor_GetTupleCount(cnx, corec);

#define __SQL_APPEND_RESULT \
    cou_sendMessageX(cnx, ap_psprintf(p, "entering __SQL_APPEND_RESULT with SQL: %s",SQLString), CO_MSG_DEBUG); \
    cor_AppendOnSQLString(cnx, corec, SQLString); \
    ok = cor_GetTupleCount(cnx, corec);


#define __SQL_GET_VRESULT(param_corec) \
    param_corec = cor_CreateOnSQLString(cnx, SQLString); 

#define __SQL_GET_INTEGER( var_name, format, args... ) \
    __CREATE_QUERY( format, ## args ) \
    __SQL_GET_RESULT \
    if (ok) var_name = atoi(cor_GetValue(cnx, corec,0,0)); \
    else var_name = 0; \
    __CLEAR_RESULT

#define __SQL_GET_STRING( var_name, format, args... ) \
    __CREATE_QUERY( format, ## args ) \
    __SQL_GET_RESULT \
    if (ok) var_name = ap_pstrdup(p,cor_GetValue(cnx, corec,0,0)); \
    __CLEAR_RESULT

#define __SQL_EXEC \
    cou_sendMessageX(cnx, ap_psprintf(p, "entering __SQL_EXEC with SQL: %s",SQLString), CO_MSG_DEBUG); \
    if (dirty_res) cou_sendMessageX(cnx, "DIRTY res REUSED!!!", CO_MSG_DEBUG); \
    res = PQexec(conn, SQLString); \
    if (PQresultStatus(res) != PGRES_COMMAND_OK) \
    { \
	    cou_logError(cnx, CO_LOG_ERR, "ERROR:%s", PQresultErrorMessage(res)); \
            PQclear(res); \
	    cou_logError(cnx, CO_LOG_ERR, "QUERY:\n%s", SQLString); \
            cou_error(cnx, "PQexec failed in __SQL_EXEC"); \
    } \
    ok = atoi(PQcmdTuples(res)); \
    PQclear(res);

#define __CREATE_JS \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1 && strlen(callback)>0){\
      cou_createJSFromRecordset(cnx, corec, callback); \
    }

#define __CREATE_JS_FROM(COREC_NAME) \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1 && strlen(callback)>0){\
      cou_createJSFromRecordset(cnx, COREC_NAME, callback); \
    }
/*
#define __CREATE_JS \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1){\
      const char * js_out = cou_createJSFromRecordset(cnx, corec, callback); \
      cou_sendMessageX(cnx, "we have created js", CO_MSG_DEBUG); \
      cou_jsputs(cnx,js_out); \
      cou_sendMessageX(cnx, "js sent to client", CO_MSG_DEBUG); \
    }

#define __CREATE_JS_FROM(COREC_NAME) \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1){\
      const char * js_out = cou_createJSFromRecordset(cnx, COREC_NAME, callback); \
      cou_sendMessageX(cnx, "we have created js", CO_MSG_DEBUG); \
      cou_jsputs(cnx,js_out); \
      cou_sendMessageX(cnx, "js sent to client", CO_MSG_DEBUG); \
    }
*/


#define __CREATE_JS_FROM_INTEGER(VALUE) \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1 && strlen(callback)>0){\
      cou_jsprintf(cnx, "; %s%d);", callback, VALUE); \
    }

/* ????????? */
#define __CREATE_JS_FROM_INTEGER2(VALUE) \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1){\
      memset(JSOutBuf, 0, JSBUFSIZE);\
      snprintf(JSOutBuf, JSBUFSIZE, "%s%d);", callback, VALUE); \
      cou_putJS(cnx,JSOutBuf); \
    }


#define __CREATE_JS_FROM_STRING(VALUE) \
    if(cnx->client_mode==CO_CLIENT_JS && cnx->send_data==1 && strlen(callback)>0){\
      cou_jsprintf(cnx, "; %s'%s');", callback, VALUE); \
    }


#define __CREATE_QUERY( format, args... )\
	{ int req_size; \
	if( (req_size=snprintf(SQLString, SQLBUFSIZE, format, ## args ))>=SQLBUFSIZE) {\
	    cou_logError(cnx, CO_LOG_ERR, "Required buffer size: %d", req_size); \
            cou_error(cnx, "snprintf failed in __CREATE_QUERY: buffer too small"); \
	}}

#define __APPEND_TO_QUERY( format, args... )\
	{ int req_size; \
	if( (req_size=snprintf(SQLString+strlen(SQLString), SQLBUFSIZE - strlen(SQLString), format, ## args ))>=SQLBUFSIZE) {\
	    cou_logError(cnx, CO_LOG_ERR, "Required buffer size: %d", req_size); \
            cou_error(cnx, "snprintf failed in __APPEND_TO_QUERY: buffer too small"); \
	}}


#define __RETURN_RESULT \
	dirty_res = 0; \
        cou_setReturnValue( cnx, (void*)corec, CO_RECORDSET );

#define __CLEAR_RESULT \
	dirty_res = 0; \
	cor_Clear(cnx, corec);

#define __GET_RESULT_AND_CREATE_JS \
        __SQL_GET_RESULT \
        __CREATE_JS \
	__RETURN_RESULT
/*
 * cleaning res should be left to setReturnValue
        PQclear(res);
*/

#define __PUT_HTML_FROM_FILE(filename) \
	fh = ap_pfopen(p,filename,"r"); \
	ap_send_fd(fh,r); \
	ap_pfclose(p,fh);

#define __PUT_ASP_FROM_FILE(filename) \
	co_send_activeFromFile(cnx,filename);

#define __CHECK_OBJECT_VERSION(message) \
   if(version != -1) \
      { \
        __CREATE_QUERY("SELECT version FROM co_%s_%s WHERE id=%d ",par_area, par_class, par_id); \
        __SQL_GET_RESULT \
        cur_version= atoi(cor_GetValue(cnx, corec, 0, 0)); \
        __CLEAR_RESULT \
        memset(SQLString, 0, SQLBUFSIZE); \
        if(version != cur_version) \
        { \
          cou_sendMessageX(cnx, message, CO_MSG_FORCE); \
	  return 0; \
        } \
      }	


#define __PERMISSION_GET              1
#define __PERMISSION_UPDATE           2
#define __PERMISSION_DELETE           3
#define __PERMISSION_UNDELETE         4
#define __PERMISSION_PURGE            5
#define __PERMISSION_CHANGE_ACL       6
#define __PERMISSION_SELECT           7
#define __PERMISSION_INSERT_CHILD     8
#define __PERMISSION_GET_RELATED      9
#define __PERMISSION_CREATE           10
#define __PERMISSION_EVALUATE	      11
#define __PERMISSION_GET_HISTORY      12
#define __PERMISSION_GET_ACL          13

#define __METHOD_SEC_TYPE_CLASS       1
#define __METHOD_SEC_TYPE_OBJECT      0

#define __CHECK_ACL_CLASS             1
#define __CHECK_ACL_OBJECT            0


#endif
