#ifndef COLIBH
#define COLIBH

#include "co_utils.h"
#include "co_log.h"
#include "co_action.h"

extern
int (*
co_callByName( co_context *, 
    const char* /* submodule_name*/, 
    const char* /* method_name */ )
)(co_context *, ... );

void
cou_broker( 
	const char* /* area_name */, 
	const char* /* class_name */, 
	const char* /* method_name */,
	co_context *, void * /* in_params*/ );

extern
void
cou_putJS( co_context *, const char* /* script */);

extern
const char *
cou_getCORootPath( co_context* );

extern
const char *
cou_getCOHtmlLibPath();

extern
const char *
cou_getCOJsLibPath();

extern
void
cou_error( co_context *, const char * /* error_msg */) __attribute__ ((noreturn));

/* writes message to log. */
/* WARNING: always use well-defined error messages (e.g. do not write URL, request data etc. */

//extern
//void
//cou_logError( co_context *, int /*log level*/, const char* /* message */);


extern
void *
cou_getParam( co_context *,
        /* input string in = r->args */
        const char * /* param_name */,
        const co_param_type /* param_type */,
        int * /* pointer to error number */
    );

extern
char** /* returns: pointer to the table of elements; 0 iif not found or error */
cou_getParamArray( co_context *,
        const char * /* param_name */,
        const char * /* delimiter */,
        int /* intTabOutLenMax */,
        int * /* pointer to error number */
    );


extern
void *
cou_getReturnValue( co_context *ctx,
        co_param_type result_type,
        int *err
    );

extern
void
cou_setReturnValue( co_context *ctx,
        void *result_value,
        co_param_type result_type

    );

/* ------------------------------------------------ */
/* interface to recordset */

extern
int
cou_getReturnValueRSntuples( co_context *ctx, int *err );

extern
int
cou_getReturnValueRSnfields( co_context *ctx, int *err );

extern
const char*
cou_getReturnValueRSvalue( co_context *ctx, int i, int j, int *err );

#if 0
/* not used anymore ??? */
extern
int /* ok if 0 */
cou_encodeSQL
(
    char* /* destination */,
    size_t n /* length of dest buffer */,
    const char* /* source */
);

extern
int /* ok if 0 */
cou_encodeJS
(
    char* /* destination */,
    size_t n /* length of dest buffer */,
    const char* /* source */
);
#endif	

#endif
			    