#ifndef COMODH
#define COMODH

/* internal definitions for coffice main module */
/* This structures should be not accessed from submodules */

/* WARNING: */
/* do not include other header files in this file! */

#define CO_ERR_SAVE_SIGNALS 1

#include "../coffice/mod_coffice.h"

typedef struct coffice_libinfo {
    const char *name; /* (shortened) library name */
    void *dlh;  /* library handle */
    void *new_param;  /* pointer to param struct builder */
    void *set_param;  /* pointer to param setter */
    void *get_param;  /* pointer to param getter */
    void *script;	/* pointer to precompiled script (per submodule) */
} coffice_libinfo;

struct coffice_server_conf {
    array_header *loaded_libs;
    struct JSRuntime *jsrt;
/*    struct pg_conn *dbconn;*/
    PGconn *dbconn;
    void *script_classes;	/* pointer to precompiled script */
    void *script_implementations;	/* pointer to precompiled script */
};

extern
coffice_server_conf *
cox_getCOfficeConfig( co_context *ctx );

extern int co_send_activeFromFile( co_context *ctx, const char *filename );

#endif
