#ifndef COUTILSH
#define COUTILSH

#include "libpq-fe.h"
#include "co_context.h"

#define CO_DEBUG 1
#define CO_NO_ERRORS 0

/* getParam/getParamArray error constants */
#define CO_NO_PARAMETERS_FOUND -1
#define CO_PARAMETER_NOT_FOUND -2
#define CO_BUFFER_TOO_SMALL -3
#define CO_GET_SQL_NAME_FAILED -5
#define CO_ERR_TYPE_MISMATCH -100

/* broker error constants */
#define CO_BROKER_ERROR -200
#define CO_METHOD_NOT_FOUND (CO_BROKER_ERROR-1)
#define CO_METHOD_FORBIDDEN (CO_BROKER_ERROR-2)
/* method implementation returned non-0 value (e.g. parameter not optional): */
#define CO_METHOD_FAILED (CO_BROKER_ERROR-3)

/* getParam types */
typedef co_value_type co_param_type;

/* cou_decode_string overwrites string with its decoded value */
/* converts %HH */
extern void
cou_decode_string (char *s);

extern void
cou_decode_string_post (char *s); // assumes that space is encoded as '+'

extern const char* cou_buildEncodedSQL(co_context *ctx, const char *source);
extern const char* cou_buildEncodedSQLArrayField(co_context *ctx, const char *source);
extern const char* cou_buildEncodedJS(co_context *ctx, const char *source);
extern const char* cou_buildHTMLEncodedTextDocument(co_context *ctx, const char *source);
extern const char* cou_buildTEXTAREAEncodedTextDocument(co_context *ctx, const char *source);
extern const char* cou_buildEncodedHTMLForScript(co_context *ctx, const char *source);
extern const char* cou_createJSFromRsX        (co_context *ctx, PGresult *res, const char* callback); 
extern const char* cou_createJSHeadFromRsX    (co_context *ctx, PGresult *res);
extern const char* cou_createJSBodyFromRsX    (co_context *ctx, PGresult *res);
extern const char* cou_createJSBodyFromRsRowX (co_context *ctx, PGresult *res, int row_num, int in_js_num);
extern const char* cou_createJSCallbackFromRsX(co_context *ctx, const char * callback);

char* cou_spaceTrim(co_context *ctx, const char *source);
/* helper functions that writes error message */
#define CO_MESBUFSIZE 10000
#define CO_MSG_FORCE 0 /* force sending message to client */ 
#define CO_MSG_ERROR 1 /* send when debug level >0 */
#define CO_MSG_DEBUG 2 /* send when debug_level >1 */
int cou_sendMessage (co_context *ctx, const char * message);
int cou_sendMessageX(co_context *ctx, const char * message, int);

#endif
