 
          DROP FUNCTION co_sys_expression_fillV(int,int,int,int)
 
          !NOERROR 
          CREATE FUNCTION  co_sys_expression_fillV(int,int,int,int)

          RETURNS  float4
          AS ' 
 
DECLARE
    _id_spreadsheet ALIAS FOR $1;
    _id_column ALIAS FOR $2;
    _id_row ALIAS FOR $3;
    _id_row_last ALIAS FOR $4;
    _nr_row_first INTEGER;
    _nr_row_last INTEGER;
BEGIN
    SELECT row_number INTO _nr_row_first FROM co_sys_spreadsheet_row
        WHERE
        id = _id_row
    ;
    SELECT row_number INTO _nr_row_last FROM co_sys_spreadsheet_row
        WHERE
        id = _id_row_last
    ;
    DELETE FROM co_sys_expression
        WHERE EXISTS(
            SELECT * FROM co_sys_spreadsheet_row  AS ROW
                WHERE
                ROW.id = id_row AND
                ROW.row_number > _nr_row_first AND
                ROW.row_number <= _nr_row_last
            )
	    AND id_column = _id_column
    ;
    /* referred column id never change; ref. row id may change */
    INSERT INTO co_sys_expression
        SELECT
        RANGE.version,
        RANGE.deleted,
        RANGE.id_spreadsheet,
        RANGE.id_column,
        ROW.id,
        RANGE.expression_parsed

        FROM
            co_sys_expression AS RANGE,
            co_sys_spreadsheet_row AS ROW
        WHERE
            RANGE.id_spreadsheet = _id_spreadsheet AND
            RANGE.id_column = _id_column AND
            RANGE.id_row = _id_row AND
            ROW.spreadsheet_id = _id_spreadsheet AND
            ROW.row_number > _nr_row_first AND
            ROW.row_number <= _nr_row_last
    ;
RETURN 0;

END;
    

    ' LANGUAGE 'plpgsql'
    !GO 
  
  DROP FUNCTION co_sys_expression_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_sys_expression_check_acl(int,int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_object = $1
	 AND id_permission = $2
	 AND id_role = $3
	
' LANGUAGE 'sql' 
!GO 
  
  DROP FUNCTION co_sys_expression_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_sys_expression_check_acl_class(int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl_class WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_permission = $1
	 AND id_role = $2
	
 
 ' LANGUAGE 'sql'   
    !GO 
  
     DROP FUNCTION lhlo_sys_expression_version(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_version(int) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.version = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_deleted(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_deleted(int) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.deleted = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_id_spreadsheet(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_id_spreadsheet(int) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.id_spreadsheet = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_id_column(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_id_column(int) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.id_column = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_id_row(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_id_row(int) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.id_row = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_expression_parsed(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_expression_parsed(text) RETURNS co_sys_expression AS
     '
        SELECT * FROM co_sys_expression WHERE co_sys_expression.expression_parsed = $1
     '
     LANGUAGE 'sql'
     !GO
       