 
          DROP FUNCTION co_sys_expression_cell_fillV(int,int,int,int)
 
          !NOERROR 
          CREATE FUNCTION  co_sys_expression_cell_fillV(int,int,int,int)

          RETURNS  float4
          AS ' 
 
DECLARE
    _id_spreadsheet ALIAS FOR $1;
    _id_column ALIAS FOR $2;
    _id_row ALIAS FOR $3;
    _id_row_last ALIAS FOR $4;
    _nr_row_first INTEGER;
    _nr_row_last INTEGER;
    _reference co_sys_expression_cell%ROWTYPE;
BEGIN
    SELECT row_number INTO _nr_row_first FROM co_sys_spreadsheet_row
        WHERE
        id = _id_row
    ;
    SELECT row_number INTO _nr_row_last FROM co_sys_spreadsheet_row
        WHERE
        id = _id_row_last
    ;
    DELETE FROM co_sys_expression_cell
        WHERE EXISTS(
            SELECT * FROM co_sys_spreadsheet_row  AS ROW
                WHERE
                ROW.id = id_row AND
                ROW.row_number > _nr_row_first AND
                ROW.row_number <= _nr_row_last
            )
	    AND id_column = _id_column
    ;
    /* referred column id never change; ref. row id may change */
    INSERT INTO co_sys_expression_cell
        SELECT
        RANGE.version,
        RANGE.deleted,
        RANGE.id_spreadsheet,
        RANGE.id_column,
        ROW.id,
        RANGE.index_ref,
        RANGE.id_ref_spreadsheet,
        NEWREFROW.id,/* update as you go; depends on is_ref_row_hard */
        RANGE.id_ref_column,
        RANGE.is_ref_row_hard,
        RANGE.is_ref_column_hard,
        RANGE.is_ref_row_named,
        RANGE.is_ref_column_named

        FROM
            co_sys_expression_cell AS RANGE,
            co_sys_spreadsheet_row AS ROW,
            co_sys_spreadsheet_row AS REFROW,
            co_sys_spreadsheet_row AS NEWREFROW
        WHERE
            RANGE.id_spreadsheet = _id_spreadsheet AND
            RANGE.id_column = _id_column AND
            RANGE.id_row = _id_row AND
            ROW.spreadsheet_id = _id_spreadsheet AND
            ROW.row_number > _nr_row_first AND
            ROW.row_number <= _nr_row_last AND
            REFROW.id = RANGE.id_ref_row AND
            NEWREFROW.spreadsheet_id = _id_spreadsheet AND
            (
            (NEWREFROW.row_number = REFROW.row_number + (ROW.row_number - _nr_row_first)
                AND NOT RANGE.is_ref_row_hard) OR (
                NEWREFROW.id = REFROW.id AND RANGE.is_ref_row_hard)
            )
    ;
RETURN 0;

END;
    

    ' LANGUAGE 'plpgsql'
    !GO 
  
  DROP FUNCTION co_sys_expression_cell_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_sys_expression_cell_check_acl(int,int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_object = $1
	 AND id_permission = $2
	 AND id_role = $3
	
' LANGUAGE 'sql' 
!GO 
  
  DROP FUNCTION co_sys_expression_cell_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_sys_expression_cell_check_acl_class(int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl_class WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_permission = $1
	 AND id_role = $2
	
 
 ' LANGUAGE 'sql'   
    !GO 
  
     DROP FUNCTION lhlo_sys_expression_cell_version(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_version(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.version = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_deleted(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_deleted(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.deleted = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_spreadsheet(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_spreadsheet(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_spreadsheet = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_column(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_column(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_column = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_row(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_row(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_row = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_index_ref(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_index_ref(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.index_ref = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_ref_spreadsheet(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_ref_spreadsheet(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_ref_spreadsheet = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_ref_row(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_ref_row(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_ref_row = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_id_ref_column(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_id_ref_column(int) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.id_ref_column = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_is_ref_row_hard(bool)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_is_ref_row_hard(bool) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.is_ref_row_hard = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_is_ref_column_hard(bool)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_is_ref_column_hard(bool) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.is_ref_column_hard = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_is_ref_row_named(bool)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_is_ref_row_named(bool) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.is_ref_row_named = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_expression_cell_is_ref_column_named(bool)
     !NOERROR

     CREATE FUNCTION lhlo_sys_expression_cell_is_ref_column_named(bool) RETURNS co_sys_expression_cell AS
     '
        SELECT * FROM co_sys_expression_cell WHERE co_sys_expression_cell.is_ref_column_named = $1
     '
     LANGUAGE 'sql'
     !GO
       