 
          DROP FUNCTION co_sys_meta_vtable_generate(text)
 
          !NOERROR 
          CREATE FUNCTION  co_sys_meta_vtable_generate(text)

          RETURNS  int
          AS ' 
 
     DECLARE
       _class_name ALIAS FOR $1;
       _current_class text;
       _force_sec_type int;
     BEGIN
      
        SELECT force_sec_type INTO _force_sec_type FROM co_sys_meta_class WHERE class_name = _class_name;
        delete from co_sys_meta_vtable where class_name = _class_name;
	  
        _current_class := _class_name;
       WHILE NOT(_current_class ISNULL) AND char_length(_current_class::text) > 0 LOOP
	        
         INSERT INTO co_sys_meta_vtable(class_name, method_name, target_class_name, id_permission, 
                                                 id_onbefore_script, id_onbefore_method, id_onafter_script, id_onafter_method, profiled, sec_type, force_sec_type)
         SELECT _class_name, method_name, _current_class, id_permission, 
                id_onbefore_script, id_onbefore_method, id_onafter_script, id_onafter_method, profiled, sec_type, _force_sec_type
            FROM co_sys_meta_method  
            WHERE _current_class = class_name AND NOT 
               method_name IN
               (
                SELECT method_name FROM co_sys_meta_vtable  
                WHERE _class_name = class_name
               );
            
         select inherits_from into  _current_class from co_sys_meta_class where class_name = _current_class;
					   
       END LOOP;
					    
       RETURN 1;
    END;  
    

    ' LANGUAGE 'plpgsql'
    !GO 
  
          DROP FUNCTION co_sys_meta_vtable_test_acl(co_sys_meta_vtable, int, int)
 
          !NOERROR 
          CREATE FUNCTION  co_sys_meta_vtable_test_acl(co_sys_meta_vtable, int, int)

          RETURNS  int
          AS ' 
 
  SELECT
    CASE WHEN $1.sec_type=1 OR $1.force_sec_type=1
      THEN
        co_sec_acl_class_check(\'sys\', $1.class_name, $1.id_permission, $3)
      ELSE
        co_sec_acl_check(\'sys\', $1.class_name, $2, $1.id_permission, $3)
      END; 
     

    ' LANGUAGE 'sql'
    !GO 
  
  DROP FUNCTION co_sys_meta_vtable_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_sys_meta_vtable_check_acl(int,int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl_class WHERE area = \'sys\' AND class_name = \'meta_vtable\' AND id_permission = $1 AND id_role = $2 ; 
' LANGUAGE 'sql' 
!GO 
  
  DROP FUNCTION co_sys_meta_vtable_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_sys_meta_vtable_check_acl_class(int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl_class WHERE area = \'sys\' AND class_name = \'meta_vtable\' AND id_permission = $1 AND id_role = $2 ; 
 
 ' LANGUAGE 'sql'   
    !GO 
  
     DROP FUNCTION lhlo_sys_meta_vtable_id(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_version(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_version(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.version = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_deleted(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_deleted(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.deleted = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_inherits_acl(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_inherits_acl(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.inherits_acl = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_class_name(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_class_name(text) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.class_name = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_method_name(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_method_name(text) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.method_name = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_target_class_name(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_target_class_name(text) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.target_class_name = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_id_permission(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id_permission(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id_permission = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_id_onbefore_script(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id_onbefore_script(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id_onbefore_script = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_id_onbefore_method(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id_onbefore_method(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id_onbefore_method = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_id_onafter_script(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id_onafter_script(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id_onafter_script = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_id_onafter_method(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_id_onafter_method(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.id_onafter_method = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_profiled(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_profiled(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.profiled = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_sec_type(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_sec_type(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.sec_type = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_meta_vtable_force_sec_type(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_meta_vtable_force_sec_type(int) RETURNS co_sys_meta_vtable AS
     '
        SELECT * FROM co_sys_meta_vtable WHERE co_sys_meta_vtable.force_sec_type = $1
     '
     LANGUAGE 'sql'
     !GO
       