 
  DROP FUNCTION co_sys_spreadsheet_cell_check_acl(int,int,int) 
  !NOERROR 
  CREATE FUNCTION  co_sys_spreadsheet_cell_check_acl(int,int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_object = $1
	 AND id_permission = $2
	 AND id_role = $3
	
' LANGUAGE 'sql' 
!GO 
  
  DROP FUNCTION co_sys_spreadsheet_cell_check_acl_class(int,int)
  !NOERROR 
  CREATE FUNCTION  co_sys_spreadsheet_cell_check_acl_class(int,int)
  RETURNS  int
  AS ' 
SELECT 1 FROM co_sec_acl_class WHERE
         area = \'sys\'
	 AND class_name = \'spreadsheet\'
	 AND id_permission = $1
	 AND id_role = $2
	
 
 ' LANGUAGE 'sql'   
    !GO 
  
     DROP FUNCTION lhlo_sys_spreadsheet_cell_id(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_id(int) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.id = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_version(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_version(int) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.version = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_deleted(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_deleted(int) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.deleted = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_column_id(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_column_id(int) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.column_id = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_row_id(int)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_row_id(int) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.row_id = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_type(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_type(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.type = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_value(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_value(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.value = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_value_num(numeric)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_value_num(numeric) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.value_num = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_value_date(date)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_value_date(date) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.value_date = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_align(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_align(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.align = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_fontsize(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_fontsize(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.fontsize = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_textstyle(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_textstyle(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.textstyle = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_textcolor(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_textcolor(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.textcolor = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION lhlo_sys_spreadsheet_cell_fontfamily(text)
     !NOERROR

     CREATE FUNCTION lhlo_sys_spreadsheet_cell_fontfamily(text) RETURNS co_sys_spreadsheet_cell AS
     '
        SELECT * FROM co_sys_spreadsheet_cell WHERE co_sys_spreadsheet_cell.fontfamily = $1
     '
     LANGUAGE 'sql'
     !GO
        
     DROP FUNCTION cof_sys_spreadsheet_cell_column_number(co_sys_spreadsheet_cell)
     !NOERROR

     CREATE FUNCTION  cof_sys_spreadsheet_cell_column_number(co_sys_spreadsheet_cell)
            RETURNS int AS
     '
select column_number from co_sys_spreadsheet_column where id=($1.column_id);

     '
     LANGUAGE 'sql'
     !GO
       
     DROP FUNCTION cof_sys_spreadsheet_cell_row_number(co_sys_spreadsheet_cell)
     !NOERROR

     CREATE FUNCTION  cof_sys_spreadsheet_cell_row_number(co_sys_spreadsheet_cell)
            RETURNS int AS
     '
select row_number from co_sys_spreadsheet_row where id=($1.row_id);

     '
     LANGUAGE 'sql'
     !GO
      