#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='System'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , 'System' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'user') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , (SELECT id FROM co_sec_user WHERE name = 'System') "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.user 
$result = sql_exe($conn, "DELETE FROM co_sec_user WHERE name='root'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_user (deleted  , id_role , login , passwd , name , description) 
SELECT 0 , '1' , 'root' , '\\\$1\\\$3ACFt8P2\\\$dNiPkfPtRZFsMS90d2lj61' , 'Root' , 'Initial Account' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_user_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='user';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'user'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.preference 
$result = sql_exe($conn, " INSERT INTO co_sec_preference (deleted  , language , id_user) 
SELECT 0 , 'pl' , (SELECT last_value FROM co_sec_user_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_preference_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 


###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='Root'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , 'Root' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'user') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , (SELECT id FROM co_sec_user WHERE name = 'Root') "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.role 
$result = sql_exe($conn, "DELETE FROM co_sec_role WHERE name='__public__'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_role (deleted  , name , id_catalog_type , id_parent , id_user , id_item) 
SELECT 0 , '__public__' , (SELECT id FROM co_sec_catalog_type WHERE class_name = 'user') , (SELECT id FROM co_sec_role WHERE name = 'root') , (SELECT id FROM co_sec_user WHERE name = 'System') , '0' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_role_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='role';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'role'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.user 
$result = sql_exe($conn, "DELETE FROM co_sec_user WHERE name='__public__'"); 
$result = sql_exe($conn, " INSERT INTO co_sec_user (deleted  , id_role , login , passwd , name , description) 
SELECT 0 , '0' , '__public__' , '' , '__public__' , 'Account for internet not authenticated users' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_user_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sec' AND class_name='user';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sec', 'user'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sec.preference 
$result = sql_exe($conn, " INSERT INTO co_sec_preference (deleted  , language , id_user) 
SELECT 0 , 'pl' , (SELECT last_value FROM co_sec_user_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sec_preference_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
