#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '
//spreadsheet functions library

 function spreadsheet_cell_getAttribute(atr_name)
 // returns attribute(attr_name) of cell object
 {
   return (this.objM.getAttribute(this.id_spreadsheet, this.id_column, this.id_row, atr_name));
 }

 function spreadsheet_column_getAttribute(atr_name)
 // gets column attribute
 {
   return this.objM.getAttribute(this.id_spreadsheet, this.id_column, atr_name);
 }

 function spreadsheet_column_setAttribute(atr_name,vle)
 // sets attribute of cell (c_n,r_n)
 {
   this.objM.setAttribute(this.id_spreadsheet, this.id_column, atr_name, vle);
 }

 function spreadsheet_row_getAttribute(atr_name)
 // gets row attribute
 {
   return this.objM.getAttribute(this.id_spreadsheet, this.id_row, atr_name);
 }

 function spreadsheet_row_setAttribute(atr_name,vle)
 // sets attribute of cell (c_n,r_n)
 {
   this.objM.setAttribute(this.id_spreadsheet, this.id_row, atr_name, vle);
 }

 function spreadsheet_cell_setAttribute(atr_name,vle)
 // sets attribute of cell (c_n,r_n)
 {
   this.objM.setAttribute(this.id_spreadsheet, this.id_column, this.id_row, atr_name, vle);
 }

 function spreadsheet_rectangle_setAttribute(atr_name,vle)
 // sets attribute of rectangle (c1_n,r1_n,c2_n,r2_n)
 {
   this.objM.setAttribute(this.id_spreadsheet, this.id_column1, this.id_row1, this.id_column2, this.id_row2, atr_name, vle);
 }

 function spreadsheet_cell_column()
 // return column that contains our cell
 {
   return (new spreadsheet_column(this.id_spreadsheet,this.id_column));
 }

 function spreadsheet_cell_row()
 // return row that contains our cell
 {
   return (new spreadsheet_row(this.id_spreadsheet,this.id_row));
 }

 function spreadsheet_showInfo()
 {
   var strInfo = \\\"\\\";

   strInfo+= \\\"spreadsheet_id=\\\"+this.id;
   strInfo+= \\\"; cols=\\\"+this.columnCount;
   strInfo+= \\\"; rows=\\\"+this.rowCount;

   ap_write(\\\"alert(\\\'\\\"+strInfo+\\\"\\\');\\\");
 }

 function spreadsheet(id)
 {
// interface to proper apache module
   this.objM = new class_spreadsheet(\\\"sys\\\");

// attributes
   this.id = id;

   this.column_ids = this.objM.getAllColumnIds(id);
   this.row_ids = this.objM.getAllRowIds(id);

   this.columnCount = this.column_ids.getTupleCount();
   this.rowCount = this.row_ids.getTupleCount();

// methods
   this.showInfo = spreadsheet_showInfo;
   this.columns = spreadsheet_columns;
   this.rows = spreadsheet_rows;
   this.cells = spreadsheet_cells;
   this.rectangles = spreadsheet_rectangles;
 }

 function spreadsheet_columns(c_n)
 {
   var c_id = (c_n > this.columnCount) ? this.column_ids.getValue(this.columnCount-1,0) : this.column_ids.getValue(c_n-1,0);
   return (new spreadsheet_column(this.id,c_id));
 }

 function spreadsheet_rows(r_n)
 {
   var r_id = (r_n > this.rowCount) ? this.row_ids.getValue(this.rowCount-1,0) : this.row_ids.getValue(r_n-1,0);
   return (new spreadsheet_row(this.id,r_id));
 }

 function spreadsheet_cells(c_n,r_n)
 {
   var c_id = (c_n > this.columnCount) ? this.column_ids.getValue(this.columnCount-1,0) : this.column_ids.getValue(c_n-1,0);
   var r_id = (r_n > this.rowCount) ? this.row_ids.getValue(this.rowCount-1,0) : this.row_ids.getValue(r_n-1,0);
   return (new spreadsheet_cell(this.id, c_id, r_id));
 }

 function spreadsheet_rectangles(c1_n,r1_n,c2_n,r2_n)
 {
   var c1_id = (c1_n > this.columnCount) ? this.column_ids.getValue(this.columnCount-1,0) : this.column_ids.getValue(c1_n-1,0);
   var r1_id = (r1_n > this.rowCount) ? this.row_ids.getValue(this.rowCount-1,0) : this.row_ids.getValue(r1_n-1,0);
   var c2_id = (c2_n > this.columnCount) ? this.column_ids.getValue(this.columnCount-1,0) : this.column_ids.getValue(c2_n-1,0);
   var r2_id = (r2_n > this.rowCount) ? this.row_ids.getValue(this.rowCount-1,0) : this.row_ids.getValue(r2_n-1,0);
   return (new spreadsheet_rectangle(this.id, c1_id, r1_id, c2_id, r2_id));
 }

 function spreadsheet_column(id_s,id_c)
 {
// interface to proper apache module
   this.objM = new class_spreadsheet_column(\\\"sys\\\");

// attributes

   this.id_spreadsheet = id_s;
   this.id_column = id_c;

// methods 

   this.setAttribute = spreadsheet_column_setAttribute;
   this.getAttribute = spreadsheet_column_getAttribute;
 }

 function spreadsheet_row(id_s,id_r)
 {
// interface to proper apache module
   this.objM = new class_spreadsheet_row(\\\"sys\\\");

// attributes

   this.id_spreadsheet = id_s;
   this.id_row = id_r;

// methods 

   this.setAttribute = spreadsheet_row_setAttribute;
   this.getAttribute = spreadsheet_row_getAttribute;
 }

 function spreadsheet_cell(id_s,id_c,id_r)
 {
// interface to proper apache module
   this.objM = new class_spreadsheet_cell(\\\"sys\\\");

// attributes

   this.id_spreadsheet = id_s;
   this.id_column = id_c;
   this.id_row = id_r;

// methods

   this.setAttribute = spreadsheet_cell_setAttribute;
   this.getAttribute = spreadsheet_cell_getAttribute;
   this.column = spreadsheet_cell_column;
   this.row = spreadsheet_cell_row;
 }

 function spreadsheet_rectangle(id_s,id_c1,id_r1,id_c2,id_r2)
 {
// interface to proper apache module
   this.objM = new class_spreadsheet_rectangle(\\\"sys\\\");

// attributes

   this.id_spreadsheet = id_s;
   this.id_column1 = id_c1;
   this.id_row1 = id_r1;
   this.id_column2 = id_c2;
   this.id_row2 = id_r2;

// methods

   this.setAttribute = spreadsheet_rectangle_setAttribute;
//   this.getAttribute = spreadsheet_cell_getAttribute;
 }

//end of spreadsheet functions library

 var sp = new spreadsheet(context.id_spreadsheet);

 function v(c_n,r_n)
 {
   return sp.cells(c_n,r_n).getAttribute(\\\"value\\\");
 }

 function sv(c_n,r_n,vle)
 {
   return sp.cells(c_n,r_n).setAttribute(\\\"value\\\",vle);
 }

' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_lib 
$result = sql_exe($conn, "DELETE FROM co_sys_js_lib WHERE name='co_spreadsheet'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_js_lib (deleted  , name , id_parent , id_js_code) 
SELECT 0 , 'co_spreadsheet' , (SELECT id FROM co_sys_js_lib WHERE name = 'root') , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_lib_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_lib';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_lib'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='user')
				 AND area='sys' AND class_name='js_lib';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_lib'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'user'
				 ");
                         