#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sys.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_sys_catalog_type WHERE class_name='catalog'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_catalog_type (deleted  , parent_class , class_name , create_params , container) 
SELECT 0 , 'catalog' , 'catalog' , '' , '1' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_sys_catalog_type WHERE class_name='spreadsheet'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_catalog_type (deleted  , parent_class , class_name , create_params) 
SELECT 0 , 'catalog' , 'spreadsheet' , '     name[0]=\\\"columns\\\";
     name[1]=\\\"rows\\\";
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_sys_catalog_type WHERE class_name='text_document'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_catalog_type (deleted  , parent_class , class_name , create_params) 
SELECT 0 , 'catalog' , 'text_document' , '' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_sys_catalog_type WHERE class_name='attachment'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_catalog_type (deleted  , parent_class , class_name , create_params) 
SELECT 0 , 'catalog' , 'attachment' , '' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_usr_catalog_type WHERE class_name='app_action'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_catalog_type (deleted  , parent_class , class_name , container , create_params) 
SELECT 0 , 'app_action' , 'app_action' , '1' , '     name[0]=\\\"link2action\\\";
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_usr_catalog_type WHERE class_name='sdoc'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_catalog_type (deleted  , parent_class , class_name , container , create_params) 
SELECT 0 , 'sdoc' , 'sdoc' , '1' , '     name[0]=\\\"main_text\\\";
     name[1]=\\\"approved\\\";
     name[2]=\\\"sposition\\\";
     name[3]=\\\"id_sdoc_tag\\\";
     name[4]=\\\"comment\\\";
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS usr.catalog_type 
$result = sql_exe($conn, "DELETE FROM co_usr_catalog_type WHERE class_name='sdoc_tag'"); 
$result = sql_exe($conn, " INSERT INTO co_usr_catalog_type (deleted  , parent_class , class_name , container , create_params) 
SELECT 0 , 'sdoc_tag' , 'sdoc_tag' , '1' , '     name[0]=\\\"cardinality\\\";
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_usr_catalog_type_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='usr' AND class_name='catalog_type';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'usr', 'catalog_type'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         