#!/usr/bin/perl
######################### We start with some black magic to print on failure.
BEGIN { $| = 1; }
END {print "test failed \n" unless \$loaded;}
use Pg;
$loaded = 1;
use strict;
######################### End of black magic.
##my $dbmain = 'nobody';
##my $dbname = 'nobody';
my $dbconnstr = 'dbname=nobody';
my $trace  = '/tmp/pgtrace.out';
my ($conn, $result, $i, $last_id);
my $DEBUG  = 0; # set this to 1 for traces
$SIG{PIPE} = sub { print "broken pipe \n" };
$dbconnstr = $ARGV[0]; shift;
######################### create and connect to database
my $Option_ref = Pg::conndefaults();
my ($key, $val);
( $$Option_ref{port} ne "" && $$Option_ref{dbname} ne "" && $$Option_ref{user} ne "" )
and print "Pg::conndefaults ........ ok \n"
or  die   "Pg::conndefaults ........ not ok: ", $conn->errorMessage;
sub sql_exe
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_COMMAND_OK ne $ret->resultStatus) 
   {
      $!=-1; 
      die "SQL: ".$sql." ".$conn->errorMessage;
   }
   return $ret;
}

sub sql_sel
{
   my($conn, $sql) = @_;
   my($ret) = $conn->exec($sql); # || die "ERROR in executing $sql \n" ;
   if(PGRES_TUPLES_OK ne $ret->resultStatus)
   {
       $!=-1; 
       die "SQL: ".$sql." ".$conn->errorMessage;
   }  
   return $ret;
}

my(@parents);

$conn = Pg::connectdb($dbconnstr);
( PGRES_CONNECTION_OK eq $conn->status )
    and print "Pg::connectdb ........... ok \n"
    or  die   "Pg::connectdb ........... not ok: ", $conn->errorMessage;  


###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '      function alert(strMsg) { ap_write(\\\'alert(\\\"\\\'+strMsg+\\\'\\\");\\\'); };
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_lib 
$result = sql_exe($conn, "DELETE FROM co_sys_js_lib WHERE name='client'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_js_lib (deleted  , name , id_js_code) 
SELECT 0 , 'client' , (SELECT last_value FROM co_sys_js_code_sqid) "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_lib_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_lib';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_lib'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_code 
$result = sql_exe($conn, " INSERT INTO co_sys_js_code (deleted  , code) 
SELECT 0 , '      function xxx(a)
       {
         return b*2;
       };
' "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_code_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_code';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_code'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         

###########################################################################################
#AREA.CLASS sys.js_lib 
$result = sql_exe($conn, "DELETE FROM co_sys_js_lib WHERE name='client2'"); 
$result = sql_exe($conn, " INSERT INTO co_sys_js_lib (deleted  , name , id_js_code , id_parent) 
SELECT 0 , 'client2' , (SELECT last_value FROM co_sys_js_code_sqid) , (SELECT id FROM co_sys_js_lib WHERE name = 'client') "); 
$result = sql_sel($conn, "SELECT last_value FROM co_sys_js_lib_sqid");
                  $last_id = ($result->fetchrow)[0]; 
$parents[0]=$last_id; 
sql_exe($conn, "
				 DELETE FROM co_sec_acl
				 WHERE id_object=$last_id AND
				 id_role=(SELECT r.id from co_sec_role r WHERE r.name='root')
				 AND area='sys' AND class_name='js_lib';
				 INSERT INTO co_sec_acl
                                 SELECT NEXTVAL('co_sec_acl_sqid'),0,0, p.id, $last_id, r.id, 'sys', 'js_lib'
                                 FROM  co_sec_permission p, co_sec_role r
				 WHERE r.name= 'root'
				 ");
                         