#!/usr/bin/perl  
# use co_modules_functions;
#use strict;
use co;
use tools;
use co_modules_functions;

#$user = $ENV{"USER"};

my($root, $item_list, $files, $prop, $file);

my($method_header) = 
'
';

#Getting the parsed tree
$root = &co::parse("sss", $ARGV[0]);

print "begining \n";


$item_list = $root->{"item_list"}; 

#creating type map
my($arr_type) = $item_list->{"type"};

print "We have $#{@$arr_type} types \n";

my($type);
%co_type_map;
foreach $type (@$arr_type)
{
    my($name_type) = $type->{"V"};
    my($name_c_type) = $type->{"c_type"}->[0]->{"V"}; 
    my($name_js_type) = $type->{"js_type"}->[0]->{"V"}; 
    my($name_pointer) = $type->{"pointer"}->[0]->{"V"}; 
    my($name_is_array) = $type->{"is_array"}->[0]->{"V"}; 
    
    $co_type_map{$name_type} = { "c_type" => $name_c_type, "js_type" => $name_js_type, "pointer" => $name_pointer, "is_array" => $name_is_array};
#    print $co_type_map{$name_type}{"c_type"} . "\n" ;

};    

my($arr_class) = $item_list->{"class"};

my($class);
foreach $class (@$arr_class)
{
     my($name_class) = $class->{"V"};
 
     open (OUTF , "> co_$name_class.c") || die "Could not open co_$name_class.c";
    
     # printing header for each class c-file
     print OUTF "
  #include \"httpd.h\"
  
  /* PostgreSQL access functions */
  #include \"libpq-fe.h\"
  #include <stdlib.h>
  #include <unistd.h>
  
  #include \"co_lib.h\"
  #include \"co_convutils.h\"
  #include \"../coffice/co_recordset.h\"
  #include \"../coffice/co_array.h\"
  #include \"../coffice/co_string.h\"
  #include \"co_defines.h\"
  #include \"co_defines_calls.h\"
  #include \"co_${name_class}.h\"
   ";
    
     my($arr_uses) = $class->{"uses"};
     my($uses);
     foreach $uses (@$arr_uses)
     {
        my($name_uses) = $uses->{"V"};
        print OUTF "#include \"../${name_uses}/co_${name_uses}.h\" \n";
     } # uses

     my($arr_include_c) = $class->{"include_c"};
     my($include_c);
     foreach $include_c (@$arr_include_c)
     {
        my($name_include_c) = $include_c->{"V"};
        print OUTF "#include \"$name_include_c\" \n";
     } # include_c

     print OUTF "static void exit_nicely(PGconn *conn) { } \n";

     my($arr_local_method) = $class->{"local_method"};
     my($local_method);
     foreach $local_method (@$arr_local_method)
     {
        my($name_local_method) = $local_method->{"V"};

        my($arr_C) = $local_method->{"C"};
        my($C);
        foreach $C (@$arr_C)
        {
           my($name_C) = $C->{"V"};
           print OUTF print_C($name_C);
        } # foreach C
     } # foreach local_method

     my($arr_method) = $class->{"method"};
     my($method);
     foreach $method (@$arr_method)
     {
        my($name_method) = $method->{"V"};
        print OUTF "
#undef  __METHOD__
#define __METHOD__ \"$name_method\"
int co_$name_method 
               (co_context *cnx, co_typein_${name_method}* struct_in)
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       PGconn *conn = cnx->dbconn;
       PGresult *res, *return_res;
       char SQLString[SQLBUFSIZE];
       char MESGString[MESGSIZE];
       char JSOutBuf[JSBUFSIZE];
       int ok;
       int err=0;
       int dirty_res = 0;
       int return_int;
       const char *return_str;
       const char *delim = \"=\";
       const char *get_str;
       co_recordset *corec;
";
       
       print OUTF "// local declarations of variables \n ";

       my($arr_declare) = $method->{"declare"};
       my($declare);
       foreach $declare (@$arr_declare)
       {
          my($name_declare) = $declare->{"V"};
          my($arr_C) = $declare->{"C"};
          my($C);
          foreach $C (@$arr_C)
          {
             my($name_C) = $C->{"V"};
             print OUTF print_C($name_C);
          } # foreach C
        } # foreach declare


       print OUTF "// definitions for input params \n";

       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          print OUTF $c_type . " " . $name_param . "; \n" ;
       }

      print OUTF
"
      // first initialization of variables
      __INIT_VARIABLES
      
      // reading input params
      // first we check the way input params where passed
      if(struct_in)
      {
      // input params are in struct_in
";

       my($arr_param) = $method->{"param"};
       my($parama);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($name_optional) = $param->{"optional"}->[0]->{"V"};
          my($name_default) = $param->{"default"}->[0]->{"V"};
 
         printf OUTF "
         if(struct_in->control->$name_param == 1)
          {
             __PARAM_STRUCT_READ($name_param,struct_in,$name_param);
          }
          else
          {\n";

    	   if($name_optional)
           {
		print OUTF $name_default . "; \n";
    	   }else 
           {
		print OUTF " __ASSERT(0, \"Parameter $name_param not set and does not have default\"); \n";
    	   }
           print OUTF "\n          } \n ";
         
      } # foreach param

      print OUTF "
      }
      else
      {	
      //input params are in request string
";
 
       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($name_optional) = $param->{"optional"}->[0]->{"V"};
          my($name_default) = $param->{"default"}->[0]->{"V"};
 
    
	  print OUTF co_get_param($name_param,$name_type,$name_optional,$name_default, $name_class, $name_method) . "\n";
       } 
 
         print OUTF 
"       } \n ";


       my($arr_body) = $method->{"body"};
       my($body);
       foreach $body (@$arr_body)
       {
          my($name_body) = $body->{"V"};
          my($arr_C) = $body->{"C"};
          my($C);
          foreach $C (@$arr_C)
          {
             my($name_C) = $C->{"V"};
             print OUTF print_C($name_C);
          } # foreach C
        } # foreach body


     print OUTF "    
  if (dirty_res)
	cou_logError( cnx, CO_LOG_DEBUG, \"${name_class}::${name_method} has dirty res\");

  return(0);
} // end of method $name_method
" ;


  } # method

######################################################################################  
# methods for building parameter structrures

     my($arr_method) = $class->{"method"};
     my($method);
     foreach $method (@$arr_method)
     {
        my($name_method) = $method->{"V"};
 
        print OUTF " 
#undef  __METHOD__
#define __METHOD__ \"pbs_$name_method\"

co_typein_${name_method}*  
   pbs_$name_method 
   (
     co_context *cnx
   )
{
       request_rec *r = cnx->request;
       pool *p = r->pool;
       __PARAM_STRUCT_CREATE_${name_method}(param_struct)
       int err;
       const char *delim = \"=\";
       char MESGString[MESGSIZE];

       
      // definitions for input params 
";
       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          print OUTF $c_type . " " . $name_param . "; \n" ;
       }

       print OUTF "//input params are in request string \n";
      
       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($name_optional) = $param->{"optional"}->[0]->{"V"};
          my($name_default) = $param->{"default"}->[0]->{"V"};
	  print OUTF co_get_param($name_param,$name_type,$name_optional,$name_default, $name_class, $name_method, 1) . "\n";
       } 

       print OUTF "// assigning params to struct \n";

       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          print OUTF "__PARAM_STRUCT_SET($name_param, param_struct , $name_param) \n";
       }

       print OUTF "
  return(param_struct);      

} // end of pbs method $name_method
";
      
      
    } # method 
 
      
  print OUTF "// end of class $name_class \n" ;
  
  close OUTF;
    
########################################################################################
# generation of header files
#
 
  open (OUTF , "> co_$name_class.h") || die "Could not open  co_$name_class.h \n";
     
 
   my($arr_method) = $class->{"method"};
   my($method);
   foreach $method (@$arr_method)
   {
     my($name_method) = $method->{"V"};
 
     print OUTF "
     #ifndef   __CO_METHOD_PARAMS_$name_method
     #define   __CO_METHOD_PARAMS_$name_method

     #include \"../coffice/co_array.h\"

	
     typedef struct
      {
      ";

       my($with_par_id) = "__PARAMS_MAGIC_NO_PAR_ID";
       my($with_par_area) = "__PARAMS_MAGIC_NO_PAR_AREA";
       my($with_par_class) = "__PARAMS_MAGIC_NO_PAR_CLASS";

       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          print OUTF $c_type . " " . $name_param . "; \n" ;
          if($name_param eq "par_id") { $with_par_id = "__PARAMS_MAGIC_WITH_PAR_ID"; };
          if($name_param eq "par_area") { $with_par_area = "__PARAMS_MAGIC_WITH_PAR_AREA"; };
          if($name_param eq "par_class") { $with_par_class = "__PARAMS_MAGIC_WITH_PAR_CLASS"; };
       }

     print OUTF "
     }  co_typein_values_${name_method}; 

     typedef struct
      { ";
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          print OUTF "int " . $name_param . "; \n" ;
       }

     print OUTF "
     }  co_typein_control_${name_method}; ";

     print OUTF "
     typedef struct
      {
         int magic_par_area;
         int magic_par_class;
         int magic_par_id;

         co_typein_control_${name_method} * control;
         co_typein_values_${name_method} * values;
      } co_typein_${name_method};
     
    #define __PARAM_STRUCT_CREATE_${name_method}(PARAM_STRUCT_NAME) \\
        co_typein_${name_method}  * PARAM_STRUCT_NAME  = ({ \\
        co_typein_${name_method}  * ret = ap_pcalloc(p, sizeof(co_typein_${name_method})); \\
        co_typein_control_${name_method}* control = ap_pcalloc(p, sizeof(co_typein_control_${name_method})); \\
        co_typein_values_${name_method} * values  = ap_pcalloc(p, sizeof(co_typein_values_${name_method})); \\
        ret->control = control; ret->values = values; ret->magic_par_id=$with_par_id; ret->magic_par_area=$with_par_area;ret->magic_par_class=$with_par_class;\\
        ret;});

      #endif
    ";
  } # .. method

   close OUTF;

#################################################################################################
#   interface to methods of class $class_name
     
     open (OUTF, "> coj_$name_class.c") || die "Could not open  coj_$name_class.c";

   print OUTF "
#include \"httpd.h\"
#include \"co_lib.h\"
#include \"co_defines.h\"
#include \"co_defines_calls.h\"

#include \"co_$name_class.h\"

#undef  __METHOD__
#define __METHOD__ \"coj_${name_class}\"

void *
coj_${name_class}_new_param( co_context *ctx, const char* method_name)
{
    pool *p = ctx->request->pool;

    cou_logError( ctx, CO_LOG_DEBUG, \"coj_${name_class}_new_param: called for %s\", method_name);
   ";

   my($arr_method) = $class->{"method"};
   my($method);
   foreach $method (@$arr_method)
   {
     my($name_method) = $method->{"V"};
 
    print OUTF "  
    if (strcmp(method_name, \"${name_method}\")==0) 
    {
        __PARAM_STRUCT_CREATE_${name_method}(ret_${name_method});
        cou_logError( ctx, CO_LOG_DEBUG, \"allocating param struct for ${name_method}\");
        return (void *)ret_${name_method};
    }
    ";

   } # method 

    print OUTF "
    return NULL;
}

#undef  __METHOD__
#define __METHOD__ \"coj_${name_class}_set_param\"

int
coj_${name_class}_set_param( co_context *ctx, void *ph,
        const char* method_name, const char *param_name, void *param_value)
{
    int err=0;
    cou_logError( ctx, CO_LOG_DEBUG, \"coj_${name_class}_set_param: called\");
";

   my($arr_method) = $class->{"method"};
   my($method);
   foreach $method (@$arr_method)
   {
     my($name_method) = $method->{"V"};
 
    print OUTF "  
    if (strcmp(method_name, \"${name_method}\")==0) {

	co_typein_${name_method} *p;
        p = (co_typein_${name_method}*)ph;
    ";
	
       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
 
        print OUTF "
        if (strcmp(param_name, \"${name_param}\")==0) { ";

	if ($pointer == 0) 
        {
            print OUTF " __PARAM_STRUCT_SET(*(${c_type}*)(param_value), p , ${name_param}) \n";
	} elsif ($pointer == 1) 
        {
           print OUTF " __PARAM_STRUCT_SET((${c_type})(param_value), p , ${name_param}) \n";
	}
	
        print OUTF "
          return err;
	} ";    
     
	} # @end /* params */

    print OUTF "}"

    }# @end /* methods */

   print OUTF "
    return -1; /* param not found */
} 

#undef  __METHOD__
#define __METHOD__ \"coj_${name_class}_get_param\"

void *
coj_${name_class}_get_param( co_context *ctx, void *ph,
        const char* method_name, const char *param_name, co_value_type *ptr_param_type)
{
    int err=0;
    cou_logError( ctx, CO_LOG_DEBUG, \"coj_${name_class}_get_param: called\");
";
   my($arr_method) = $class->{"method"};
   my($method);
   foreach $method (@$arr_method)
   {
     my($name_method) = $method->{"V"};
 
    print OUTF "  
    if (strcmp(method_name, \"${name_method}\")==0) {

	co_typein_${name_method} *p;
        p = (co_typein_${name_method}*)ph;
    ";
	
       my($arr_param) = $method->{"param"};
       my($param);
       foreach $param (@$arr_param)
       {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
          my($js_type) = $co_type_map{$name_type}{"js_type"};
 
          if ($js_type ne "****WRONG****") 
          {
            print OUTF "
        if (strcmp(param_name, \"${name_param}\")==0) {
	    *ptr_param_type = ${name_type};
            return &(p->values->${name_param});
	}";

          }
	} # /* params */
    print OUTF "} \n";

   } #   @end /* methods */

   print OUTF "
    *ptr_param_type = CO_NO_TYPE;
    return NULL; /* param not found */
}
";

   close OUTF;


####################################################################################################
## // JavaScript interface to methods of class $class_name
     
   open (OUTF, "> co_${name_class}.js") || die  "Could not open co_${name_class}.js" ;

   print OUTF "/* JavaScript wrapper for methods of class ${name_class} */ \n";

   my($arr_method) = $class->{"method"};
   my($method);
   foreach $method (@$arr_method)
   {
     my($name_method) = $method->{"V"};
 
     print OUTF "
/**************************************************
 definitions for ${name_class}::${name_method}
***************************************************/
";

     print OUTF "function class_${name_class}_RAW_${name_method}( \n";

     my($i)=0;
     my($arr_param) = $method->{"param"};
     my($param);
     foreach $param (@$arr_param)
     {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
          my($js_type) = $co_type_map{$name_type}{"js_type"};
 
          if($i>0 ){ print OUTF ", \n"; };
	  print OUTF  " arg_${name_param} /* $name_type */ \n";
	  $i++;
       } #@end .. param
       print OUTF "
	)
    {
	var method = new COMethod( this.strArea, this.strClass, '${name_method}' ); ";

     my($i)=0;
     my($arr_param) = $method->{"param"};
     my($param);
     foreach $param (@$arr_param)
     {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
          my($js_type) = $co_type_map{$name_type}{"js_type"};
 
          if($js_type eq "****WRONG****") 
          {  
	    print OUTF "return null; \n ";
	  } else 
          {
            print OUTF "
	if (class_${name_class}_RAW_${name_method}.arguments.length>$i) {
	   method.setParam( '${name_param}', $js_type(arg_${name_param}) );
	}";
	  }
	  $i++;
     } # param

    print OUTF "
	method.call();

	return co_getretAny();
    }

    function class_${name_class}_EXT_${name_method}( obj_arg )
    {
	var p;
	var method = new COMethod( this.strArea, this.strClass, '${name_method}' );

	for (p in obj_arg) {
	    method.setParam( p, obj_arg[p] );
	}

	method.call();

	return co_getretAny();
    }

    function class_${name_class}_${name_method}(
";

     my($i)=0;
     my($arr_param) = $method->{"param"};
     my($param);
     foreach $param (@$arr_param)
     {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
          my($js_type) = $co_type_map{$name_type}{"js_type"};
 
    	  if (!(${name_param} eq "par_class") && !(${name_param} eq "par_area") && !(${name_param} eq "callback")) 
          {
    	    if ($i != 0) { print OUTF " , \n"; };
	    print OUTF " arg_${name_param} /* $name_type */ \n" ;
	    $i++;
	  }
      } # end .. param
    print OUTF "
	)
    {
	var method = new COMethod( this.strArea, this.strClass, '${name_method}' ); \n";

     my($i)=0;
     my($arr_param) = $method->{"param"};
     my($param);
     foreach $param (@$arr_param)
     {
          my($name_param) = $param->{"V"};
          my($name_type) = $param->{"type"}->[0]->{"V"}; 
          my($c_type) = $co_type_map{$name_type}{"c_type"};  
          my($pointer) = $co_type_map{$name_type}{"pointer"};
          my($js_type) = $co_type_map{$name_type}{"js_type"};

    	  if (${name_param} eq "par_area") 
          {
	     print OUTF " method.setParam( 'par_area', this.strArea ); \n";
    	  } elsif (${name_param} eq "par_class") 
          {
	     print OUTF " method.setParam( 'par_class', this.strClass ); \n ";
    	  } elsif (${name_param} eq "callback") 
          {
	    print OUTF  " method.setParam( 'callback', '' ); \n";
    	  } else 
          {
	     print OUTF " if (class_${name_class}_${name_method}.arguments.length>$i) { \n";
             if($js_type eq "****WRONG****") 
             {  
	        print OUTF "return null; \n ";
	     } else 
             {
	        print OUTF "if (arg_${name_param}!=null) method.setParam( '${name_param}', $js_type(arg_${name_param}) ); \n";
	     }
	     print OUTF " } \n";
	     $i++;
    	  }
      } # param @end
     
     print OUTF "
	method.call();

	return co_getretAny();
    } ";

    if (${name_method} eq 'delete') {
       print OUTF "  
	class_${name_class}.prototype.EXT_del = class_${name_class}_EXT_${name_method};
	class_${name_class}.prototype.RAW_del = class_${name_class}_RAW_${name_method};
	class_${name_class}.prototype.del = class_${name_class}_${name_method};\n\n";

    } else {
       print OUTF "
	class_${name_class}.prototype.EXT_${name_method} = class_${name_class}_EXT_${name_method};
	class_${name_class}.prototype.RAW_${name_method} = class_${name_class}_RAW_${name_method};
	class_${name_class}.prototype.${name_method} = class_${name_class}_${name_method}; \n\n";

    }

    } # method @end

} #class

